/*******************************************************************************
**                                                                            **
** File:        db_interface.h                                                **
** Description: Headerfile contains all prototypes for the database interface **
** Author:                                                                    **
** Date:        1999-06-03                                                    **
** Version:     1.0                                                           ** 
** Lines:       94                                                            **
**                                                                            **
*******************************************************************************/

#include <mysql/mysql.h>

#include "packet.h"
#include "c.h"

#ifndef __DB_INTERFACE_H__
#define __DB_INTERFACE_H__

/* Status call definitions */
#define CALL_STATUS 0x0001
#define CALL_ABORT  0x0002
#define CALL_RELOAD 0x0003


MYSQL_RES* DBExec (MYSQL* conn, char * pcString);

void PutPacketData (const struct packet*);
void TerminateDB (void);

MYSQL* InitDBConn (void);
void TerminateDBConn (MYSQL* mConn);

void EmptyPackets (void);

/* Status call functions */ 
int GetCall (void);

void PutStatusData (int iStatus,
 int iTotPack, int iSnifPack, int iFiltPack, 
                    int iSnifData, int iFiltData);
					
void GetStatusData (int *iStatus,
 int *iTotPack, int *iSnifPack, int *iFiltPack, 
                    int *iSnifData, int *iFiltData);
		    
void PutCall (int iCallID);

void UpdateNoFilter (void);

void UpdateEthFilter (bool bEthernetSrcSpec, bool bEthernetDestSpec,
                      bool bEthernetProtocolSpec, char* cSourceMac, 
                      char*  cDestMac,
 int iEthernetProtocol);

void UpdateIPFilter (bool bIPSrcSpec, bool bIPDestSpec,
                     bool bIPSrcPortSpec, bool bIPDestPortSpec,
		     bool bIPProtSpec,
 char* cSourceIP, char* cDestIP,
  		     int iIPSrcPort, int iIPDestPort, int iIPProtocol);

void UpdateIPXFilter (bool bSNSpes, bool bSHSpec, bool bSSSpec,
                      bool bDNSpec, bool bDHSpec, bool bDSSpec,
                      bool bPacketType,
                      char* cSNet, char* cSHost, char* cSSocket,
                      char* cDNet, char* cDHost, char* cDSocket,
                      int IPacketType);
			
void UpdateNoStartTrigger (void);

void UpdateNoStopTrigger (void);

void UpdateEthTrigger (bool bEthernetSrcSpec, bool bEthernetDestSpec,
                       bool bEthernetProtocolSpec, char* cSourceMac,
                       char* cDestMac,
 int iEthernetProtocol);

void UpdateIPTrigger (bool bIPSrcSpec, bool bIPDestSpec,
                      bool bIPSrcPortSpec, bool bIPDestPortSpec,
		      bool bIPProtSpec, char* cSourceIP, char* cDestIP,
                      int iIPSrcPort, int iIPDestPort, int iIPProtocol);

void UpdateIPXTrigger (bool bSNSpes, bool bSHSpec, bool bSSSpec,
                       bool bDNSpec, bool bDHSpec, bool bDSSpec,
                       bool bPacketType,
                       char* cSNet,char* cSHost, char* cSSocket,
                       char* cDNet,char* cDHost, char* cDSocket,
                       int IPacketType);

void UpdateCountTrigger (int iAantalPakketten);

void UpdateStartTimeTrigger (char* cYear, 
                             char* cMonth,
                             char* cDay,
                             char* cHour,
                             char* cMin,
                             char* cSec);

void UpdateStopTimeTrigger (char* cYear,
                            char* cMonth,
                            char* cDay,
                            char* cHour,
                            char* cMin,
                            char* cSec);

#endif