/*
 * (C) 1999 by The WESP.
 */

#ifndef __FILTER_INST_H__
#define __FILTER_INST_H__

#include "types.h"

// Start settings types

#define TF_GEEN            0
#define TF_ETHERNET        1
#define TF_IP              2
#define TF_IPX             3

#define MAX_NAAM_LENGTH 16

typedef struct filter_setting
{
     char sNaam[MAX_NAAM_LENGTH+1];
     int iType;
// ETHERNET
     boolean bEthernetSrcSpec;
     boolean bEthernetDestSpec;
     boolean bEthernetProtocolSpec;
     struct ethernet_addr eaSource;
     struct ethernet_addr eaDestination;
     int iEthernetProtocol;
// IP
     boolean bIPSrcSpec;
     boolean bIPDestSpec;
     boolean bIPSrcPortSpec;
     boolean bIPDestPortSpec;
     boolean bIPProtocolSpec;
     boolean bIPDuplex;
     struct ip_addr iaSourceMask;
     struct ip_addr iaDestinationMask;
     int iIPSrcPort;
     int iIPDestPort;
     int iIPProtocol;
// IPX
     boolean bIPXSrcNetSpec;
     boolean bIPXSrcHostSpec;
     boolean bIPXSrcSocketSpec;
     boolean bIPXDestNetSpec;
     boolean bIPXDestHostSpec;
     boolean bIPXDestSocketSpec;
     boolean bIPXProtocolSpec;
     struct ipx_addr ipaSource;
     struct ipx_addr ipaDestination;
     u_int uiIPXProtocol;
} filter_setting;

boolean GetFilterSetting (const char *sSettingName, 
                          struct filter_setting *fsSetting);

#endif 