#ifndef __INTERFACE_H__
#define __INTERFACE_H__

#include <pcap.h>

/* State definitions */
#define STATE_PRE   0x01
#define STATE_IN    0x02
#define STATE_POST  0x03

#define DEFAULT_SNAPLEN 1600    /* Length of maximal packet size */
                                /* that will be captured         */

extern char *program_name;	/* used to generate self-identifying messages */
extern char *copy_argv(char **);

/* The printer routines. */
extern void default_print(const struct timeval *, const u_char *, u_int, const u_int);
extern void ether_if_print(u_char *, const struct pcap_pkthdr *, const u_char *);
extern void lo_if_print(u_char *, const struct pcap_pkthdr *, const u_char *);
extern void raw_if_print(u_char *, const struct pcap_pkthdr *, const u_char *);

extern char version[];         /* Defined in version.c  */
extern char cCopyright[];      /* Defined in version.c  */
extern char cASCIIArt[];       /* Defined in asciiart.c */
#endif
