/*
 * (C) 1999 by The WESP.
 */

#ifndef __TRIGGER_INST_H__
#define __TRIGGER_INST_H__

#include "types.h"

// Start settings types

#define TB_GEEN            0
#define TB_TIJD_START      1
#define TB_TIJD_START_STOP 2
#define TB_ETHERNET        3
#define TB_IP              4
#define TB_IPX             5

// Stop settings types

#define TS_GEEN            0
#define TS_TIJD            1
#define TS_AANTAL_PAKKET   2

#define MAX_NAAM_LENGTH 16

typedef struct trigger_setting
{
     char sNaam[MAX_NAAM_LENGTH+1];
     int iStartType;
     int iStopType;
// TIJD
     struct tijd tBegin;
     struct tijd tStop;
     boolean bAantalPakkettenSpec;
     int iAantalPakketten;
// ETHERNET
     boolean bEthernetSrcSpec;
     boolean bEthernetDestSpec;
     boolean bEthernetProtocolSpec;
     struct ethernet_addr eaSource;
     struct ethernet_addr eaDestination;
     int iEthernetProtocol;
// IP
     boolean bIPSrcSpec;
     boolean bIPDestSpec;
     boolean bIPSrcPortSpec;
     boolean bIPDestPortSpec;
     boolean bIPProtocolSpec;
     boolean bIPDuplex;
     struct ip_addr iaSource;
     struct ip_addr iaDestination;
     int iIPSrcPort;
     int iIPDestPort;
     int iIPProtocol;
// IPX
     boolean bIPXSrcNetSpec;
     boolean bIPXSrcHostSpec;
     boolean bIPXSrcSocketSpec;
     boolean bIPXDestNetSpec;
     boolean bIPXDestHostSpec;
     boolean bIPXDestSocketSpec;
     boolean bIPXProtocolSpec;
     struct ipx_addr ipaSource;
     struct ipx_addr ipaDestination;
     u_int uiIPXProtocol;
} trigger_setting;

boolean GetTriggerSetting (const char *sSettingName, struct trigger_setting *trSetting);

#endif 