/*******************************************************************************
**                                                                            **
**  File:       forms.c                                                       **
**  Desciption: CGI-Program to show the filter & strigger setting             **
**  Author:     Bjorn Vermeulen                                               **
**  Date:       1999-06-03                                                    **
**  Version:    1.0                                                           **
**  Lines:      284                                                           **
**                                                                            **
*******************************************************************************/

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "util.h"  
#include "html.h"
#include "db_interface.h"
#include "filter_inst.h"
#include "trigger_inst.h"
#include "packet.h"

MYSQL * conn;

void ShowConfigForm (void);
void ShowFilterForm (void);
void ShowFilterSetting (void);
void ShowFormHeader (char* sString);
void ShowTriggerForm (void);
void ShowTriggerSetting (void);

/************* FUNCTIONS ******************************************************/

void ShowConfigForm (void)
{
/* call 0 */
    ShowFormHeader ("WESP Configuration");
    printf ("<A HREF=\"/cgi-bin/info?name=help#config\">help</A><HR>\n");
    ShowTriggerSetting ();
    ShowFilterSetting ();
    printf ("<BR><BR>");
    printf ("Choose from the following options:\n<UL>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/settings?call=1\">Set Trigger</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/settings?call=2\">Set Filter</A></LI>\n");
    printf ("</UL>\n");    
}

void ShowFilterForm (void)
{
/* call 2*/
    ShowFormHeader ("Set Filter");
    printf ("<A HREF=\"/cgi-bin/info?name=help#filter\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=0\"><< back</A><HR>\n");
    
    ShowFilterSetting ();
    printf ("<BR><BR>");
    printf ("Choose from the following options:\n<UL>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/filter?call=6\">Set no Filter</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/filter?call=0\">Set Ethernet Filter</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/filter?call=8\">Set Ethernet Filter by name</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/filter?call=1\">Set IP Filter</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/filter?call=7\">Set IP Filter by name</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/filter?call=2\">Set IPX Filter</A></LI>\n");
    printf ("</UL>\n");    
}

void ShowFilterSetting (void)
{
    struct filter_setting fsSetting;
	
    /* get the info from database*/
    conn = InitDBConn ();
    GetFilterSetting ("default", &fsSetting);
    TerminateDB ();        

    printf("<H2>Filter ");
    switch(fsSetting.iType)
    {
    	case TF_GEEN:    
	    printf ("(NONE)</H2>\n");
            break;
        case TF_ETHERNET:
            printf ("(ETHERNET)</H2>\n");
            printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH>Source Addr<TH>Destination Addr<TH>Protocol\n");
            printf ("<TR><TD>");
            fsSetting.bEthernetSrcSpec ? PrintEthernetAddr (fsSetting.eaSource.addr) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bEthernetDestSpec ? PrintEthernetAddr (fsSetting.eaDestination.addr) : printf ("************");
            printf ("<TD>");
            fsSetting.bEthernetProtocolSpec ? printf ("%d", fsSetting.iEthernetProtocol)  : printf ("************");
            printf ("</TABLE>\n");
            break;
         case TF_IP:
            printf ("(IP)</H2>\n");
            printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH>Source Addr<TH> Source Port<TH>Destination Addr<TH>Destination Port<TH>Protocol\n");
            printf ("<TR><TD>");
            fsSetting.bIPSrcSpec ? PrintIPAddr (fsSetting.iaSourceMask.addr) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bIPSrcPortSpec ? printf ("%d", fsSetting.iIPSrcPort) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bIPDestSpec ? PrintIPAddr (fsSetting.iaDestinationMask.addr) : printf ("************");
            printf ("<TD>");
            fsSetting.bIPDestPortSpec ? printf ("%d", fsSetting.iIPDestPort) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bIPProtocolSpec ? printf("%d", fsSetting.iIPProtocol)  : printf ("************");
            printf ("</TABLE>\n");
            break;
	case TF_IPX:
            printf ("(IPX)</H2>\n");
            printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH COLSPAN=3> Source<TH COLSPAN=3> Destination <TH ROWSPAN=2>Protocol");
            printf ("<TR><TH> Addr<TH>  Host<TH> Socket<TH> Addr<TH> Host<TH> Socket \n");
            printf ("<TR><TD>");
            fsSetting.bIPXSrcNetSpec ? PrintChar (-1, (char *) &fsSetting.ipaSource.networkaddr,8) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bIPXSrcHostSpec ? PrintChar (-1, (char *) &fsSetting.ipaSource.hostaddr,12) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bIPXSrcSocketSpec ? PrintChar (-1, (char *) &fsSetting.ipaSource.socketaddr,4) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bIPXDestNetSpec ? PrintChar  (-1, (char *) &fsSetting.ipaDestination.networkaddr,8) : printf ("************");
            printf ("<TD>");
            fsSetting.bIPXDestHostSpec ? PrintChar (-1, (char *) &fsSetting.ipaDestination.hostaddr,12) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bIPXDestSocketSpec ? PrintChar (-1, (char *) &fsSetting.ipaDestination.socketaddr,4) : printf ("************");                    
            printf ("<TD>");
            fsSetting.bIPXProtocolSpec ? printf("%d", fsSetting.uiIPXProtocol)  : printf ("************");
            printf ("</TABLE>\n");
            break;
         default :
	    printf ("(Unknown type)</H2>\n");
    }      
    printf("</TABLE>");      
}

void ShowFormHeader (char* sString)
{
    printf ("<H1>%s</H1>\n",sString);
    printf ("<HR>\n");
}

void ShowTriggerForm (void)
{
/* call 1 */
    ShowFormHeader ("Set Start Trigger");
    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=0\"><< back</A><HR>\n");
    
    ShowTriggerSetting ();
    printf ("<BR><BR>");
    printf ("Choose from the following options:\n<UL>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=4\">Set no start type </A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=3\">Set start type Time </A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=0\">Set start type Ethernet </A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=15\">Set start type Ethernet by name</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=1\">Set start type IP </A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=14\">Set start type IP by name</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=2\">Set start type IPX </A></LI>\n");
    printf ("</UL>\n");    
}

void ShowTriggerSetting (void)
{
    struct trigger_setting trSetting;
	
    /* get the info from database */
    conn = InitDBConn ();
    GetTriggerSetting ("default", &trSetting);
    TerminateDB ();        
	
    printf("<H2>Start trigger ");
    switch(trSetting.iStartType)
    {
    	case TB_GEEN:    
    	    printf ("(NONE)</H2>\n");
            break;
        case TB_TIJD_START:
        case TB_TIJD_START_STOP:
            printf ("(TIME)</H2>\n");
            printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH>Year<TH>Month<TH>Day<TH>Hour<TH>Min<TH>Sec\n");
            printf ("<TR><TD>");
            PrintChar (-1, (char *) &trSetting.tBegin,4);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tBegin+4,2);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tBegin+6,2);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tBegin+8,2);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tBegin+10,2);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tBegin+12,2);
            printf ("</TABLE>\n");
            break;
         case TB_ETHERNET:
            printf ("(ETHERNET)</H2>\n");
            printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH>Source Addr<TH>Destination Addr<TH>Protocol\n");
            printf ("<TR><TD>");
            trSetting.bEthernetSrcSpec ? PrintEthernetAddr(trSetting.eaSource.addr) : printf ("************");
            printf ("<TD>");
            trSetting.bEthernetDestSpec ? PrintEthernetAddr(trSetting.eaDestination.addr) : printf ("************");
            printf ("<TD>");
            trSetting.bEthernetProtocolSpec ? printf("%d",trSetting.iEthernetProtocol)  : printf ("************");
            printf ("</TABLE>\n");
            break;
         case TB_IP:
            printf ("(IP)</H2>\n");
            printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH>Source Addr<TH> Source Port<TH>Destination Addr<TH>Destination Port<TH>Protocol\n");
            printf ("<TR><TD>");
            trSetting.bIPSrcSpec ? PrintIPAddr (trSetting.iaSource.addr) : printf ("************");
            printf ("<TD>");
            trSetting.bIPSrcPortSpec ? printf ("%d", trSetting.iIPSrcPort) : printf ("************");
            printf ("<TD>");
            trSetting.bIPDestSpec ? PrintIPAddr (trSetting.iaDestination.addr) : printf ("************");
            printf ("<TD>");
            trSetting.bIPDestPortSpec ? printf ("%d", trSetting.iIPDestPort) : printf ("************");
            printf ("<TD>");
            trSetting.bIPProtocolSpec ? printf("%d",trSetting.iIPProtocol)  : printf ("************");
            printf ("</TABLE>\n");
            break;
	case TB_IPX:
            printf ("(IPX)</H2>\n");
            printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH>Source Addr<TH> Source Host<TH>Source Socket<TH>Destination Addr<TH>Destination Host<TH>Destination Socket<TH>Protocol\n");
            printf ("<TR><TD>");
            trSetting.bIPXSrcNetSpec ? PrintChar(-1, (char *) &trSetting.ipaSource.networkaddr,8) : printf ("************");
            printf ("<TD>");
            trSetting.bIPXSrcHostSpec ? PrintChar (-1, (char *) &trSetting.ipaSource.hostaddr,12) : printf ("************");
            printf ("<TD>");
            trSetting.bIPXSrcSocketSpec ? PrintChar (-1, (char *) &trSetting.ipaSource.socketaddr,4) : printf ("************");
            printf ("<TD>");
            trSetting.bIPXDestNetSpec ? PrintChar(-1, (char *) &trSetting.ipaDestination.networkaddr,8) : printf ("************");
            printf ("<TD>");
            trSetting.bIPXDestHostSpec ? PrintChar (-1,(char *) &trSetting.ipaDestination.hostaddr,12) : printf ("************");
            printf ("<TD>");
            trSetting.bIPXDestSocketSpec ? PrintChar (-1, (char *) &trSetting.ipaDestination.socketaddr,4) : printf ("************");
            printf ("<TD>");
            trSetting.bIPXProtocolSpec ? printf("%d",trSetting.uiIPXProtocol)  : printf ("************");
            printf ("</TABLE>\n");
            break;
         default :
            printf ("(Unknown type)</H2>\n");
	}
        
	printf("<H2>Stop trigger ");
  
    switch(trSetting.iStopType)
    {
	case TS_GEEN:
		printf ("(NONE)</H2>\n");
	        break;
	case TS_TIJD:
            printf ("(TIME)</H2>\n");
	    printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH>Year<TH>Month<TH>Day<TH>Hour<TH>Min<TH>Sec\n");
            printf ("<TR><TD>");
            PrintChar (-1, (char *) &trSetting.tStop,4);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tStop+4,2);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tStop+6,2);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tStop+8,2);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tStop+10,2);
            printf ("<TD>");
            PrintChar (-1, (char *) &trSetting.tStop+12,2);
	    printf ("</TABLE>\n");
            break;
        case TS_AANTAL_PAKKET:
            printf ("(PACKETS)</H2>\n");
            printf ("<TABLE CLASS=color BORDER=1>\n");
            printf ("<TR><TH>Total Packets\n");
            printf ("<TR><TD>");
            trSetting.bAantalPakkettenSpec ? printf("%d", trSetting.iAantalPakketten) : printf ("************");
	    printf ("</TABLE>\n");
            break;
        default :
            printf ("(Unknown type)</H2>\n");
     } 
} 

/* EOF */