#include "html.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

char* pcQueryString;

/************* FUNCTIONS ******************************************************/

void CGIGetEnv (char *acString, char *cReturn, int iMaxLength)
{
    int i = 0;
    char* pcParsedQueryString;

    pcParsedQueryString = malloc (1024);
    strncpy (pcParsedQueryString, pcQueryString, 1000);

	cReturn[0] = 0;
	if (pcParsedQueryString == NULL)
	{
    	    return;
	}
	if (strlen (pcParsedQueryString) == 0)
	{
	    return;
	}
	while (strncmp (acString, pcParsedQueryString, strlen (acString)) && strcmp (pcParsedQueryString, ""))
	{
	    pcParsedQueryString = (pcParsedQueryString + 1);
	}
	if (!strcmp (pcParsedQueryString, ""))
    	    return;

	pcParsedQueryString = (pcParsedQueryString + strlen (acString) + 1);
	while (pcParsedQueryString[i] != '&' && pcParsedQueryString[i] != '\0' && i + 2 < iMaxLength)
	{
    	    cReturn[i] = pcParsedQueryString[i];
	    i++;
	}
	cReturn[i] = 0;
}

void CGIParseEnv (void)
{
    char* pcMethod;

    pcMethod = getenv ("REQUEST_METHOD");

    if (strcmp (pcMethod, "GET") == 0)
    {
	pcQueryString = getenv ("QUERY_STRING");
    }
    else
    {
	pcQueryString = malloc (1024);
	scanf ("%1000s", pcQueryString);
    }
}

void HTMLBottom (void)
{
    printf ("<HR>\n&copy; 1999 by The WESP (Bjorn Vermeulen, Jeroen Scheeres and Derick Rethans)\n");
    printf ("</BODY>\n</HTML>\n");
}

void HTMLError (int iErrNr)
{
    char cError[256];
    
    printf ("<A HREF=\"/cgi-bin/info?name=help#error%d\">help</A><HR>\n", iErrNr);
    switch (iErrNr)
    {
        case 701: strcpy (cError, "The WESP ain't running.");
	          break;
        case 702: strcpy (cError, "The WESP gave back an incorrect state code.");
	          break;
	case 703: strcpy (cError, "The timestamp field isn't unique.");
	          break;
	case 704: strcpy (cError, "There is an incorrect Ethernet-type in the database.");
	          break;
	case 705: strcpy (cError, "A file couldn't be opened for reading.");
	          break;
        default:  strcpy (cError, "Don't know what went wrong.");
    }
    
    printf ("<H3>Error: %d</H3>\n", iErrNr);
    printf ("%s\n", cError);
}

void HTMLHeader (char *acTitle)
{
    printf ("Content-type: text/html\n\n");
    printf ("<HTML>\n  <HEAD>\n    <TITLE>");
    printf ("The WESP: %s", acTitle);
    printf ("</TITLE>");
    printf ("\n    <LINK REL=STYLESHEET TYPE=\"text/css\" href=\"/wesp/style.css\" >");
    printf ("\n  </HEAD>\n");
    printf ("<BODY>\n");
}

/* EOF */