/*******************************************************************************
**                                                                            **
**  File:       filter.c                                                      ** 
**  Desciption: CGI-Program to set the filter setting                         **
**  Author:     Bjorn Vermeulen                                               ** 
**  Date:       1999-06-03                                                    **
**  Version:    1.0                                                           **
**  Lines:      852                                                           **
**                                                                            **
*******************************************************************************/

#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>

#include "html.h"
#include "db_interface.h"
#include "trigger_inst.h"
#include "filter_inst.h"
#include "interface.h"
#include "util.h"
#include "c.h"
#include "forms.h"

#define BUFSIZE 7

MYSQL * conn;

static int GetPID (void);
static void ShowEthFilterForm (void);
static void ShowIPFilterForm (void);
static void ShowIPXFilterForm (void);
static void SetEthFilter(void);
static void SetIPFilter(void);
static void SetIPXFilter(void);
static void ShowUsrIPFilterForm (void);
static void ShowUsrEthFilterForm (void);
static void SetUsrIPFilter(void);
static void SetUsrEthFilter(void);

static int GetPID (void)
{
    int fd;
    char acWespID[BUFSIZE];
    if ((fd = open("/var/lock/wesp", O_RDONLY)) == -1)
    {
        return 0;
    }
    else
    {
        while ( read(fd, acWespID, BUFSIZE) >0){}
        acWespID[6]=0;       
        return atoi(acWespID);  	
    }
}

static void ShowEthFilterForm (void)
{
/* call 0 */
    printf ("<A HREF=\"/cgi-bin/infp?name=help#filter_eth\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=2\"><< back</A><HR>\n");	
    printf ("<FORM ACTION=\"/cgi-bin/filter\" METHOD=%s>",METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH COLSPAN=\"6\">Source Ethernet adres: </TH>");		
    printf ("<TR><TD COLSPAN=\"6\" WIDTH=\"300\"><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm1\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm2\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm3\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm4\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm5\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm6\">\n");
    printf ("<TR><TH COLSPAN=\"6\">Destination Ethernet adres: </TH>");		
    printf ("<TR><TD COLSPAN=\"6\" WIDTH=\"300\"><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm1\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm2\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm3\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm4\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm5\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm6\">\n");
    printf ("<TR><TH COLSPAN=\"6\">Ethernet protocol: </TH>\n");		
    printf ("<TR><TD COLSPAN=\"6\" WIDTH=\"300\"><B>\n");
    printf ("<SELECT NAME=\"fpm\"><OPTION VALUE=\"0\">ALL<OPTION VALUE=\"33079\" >IPX<OPTION VALUE=\"2054\">ARP<OPTION VALUE=\"2048\">IP\n");
    printf ("</SELECT></TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"3\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");		
}

static void ShowIPFilterForm (void)
{
/* call 1 */
    printf ("<A HREF=\"/cgi-bin/info?name=help#filter_ip\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=2\"><< back</A><HR>\n");
    printf ("<FORM ACTION=\"/cgi-bin/filter\" METHOD=%s>",METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH>Source IP adres:<TH>Source Port:");		
    printf ("<TR><TD WIDTH=\"300\"><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fsi1\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fsi2\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fsi3\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fsi4\">\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"5\" MAXLENGTH=\"5\" NAME=\"fspi\">\n");
    printf ("<TR><TH>Destination IP adres:<TH> Destination Port:");		
    printf ("<TR><TD WIDTH=\"300\"><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fdi1\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fdi2\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fdi3\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fdi4\">\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"5\" MAXLENGTH=\"5\" NAME=\"fdpi\">\n");
    printf ("<TR><TH COLSPAN=\"2\">IP Protocol: </TH>\n");		
    printf ("<TR><TD COLSPAN=\"2\"><B>\n");
    printf ("<SELECT NAME=\"fpi\"><OPTION VALUE=\"0\" >ALL<OPTION VALUE=\"17\">UDP<OPTION VALUE=\"1\">ICMP<OPTION VALUE=\"6\">TCP\n");
    printf ("</SELECT></TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"4\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");		
}

static void ShowIPXFilterForm (void)
{
/* call 2 */
    printf ("<A HREF=\"/cgi-bin/info?name=help#filter_ipx\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=2\"><< back</A><HR>\n");
    printf ("<FORM ACTION=\"/cgi-bin/filter\" METHOD=%s>",METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH COLSPAN=\"3\">Source IPX:");
    printf ("<TR><TH> NET<TH> HOST<TH>Socket");		
    printf ("<TR><TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"8\" MAXLENGTH=\"8\" NAME=\"fsnetipx\">\n");
    printf ("<TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx1\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx2\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx3\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx4\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx5\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx6\">\n");
    printf ("<TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"4\" MAXLENGTH=\"4\" NAME=\"fssocketipx\">\n");
    printf ("<TR><TH COLSPAN=\"3\">Destination IPX:");		
    printf ("<TR><TH> NET<TH> HOST<TH>Socket");		
    printf ("<TR><TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"8\" MAXLENGTH=\"8\" NAME=\"fdnetipx\">\n");
    printf ("<TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx1\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx2\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx3\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx4\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx5\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx6\">\n");
    printf ("<TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"4\" MAXLENGTH=\"4\" NAME=\"fdsocketipx\">\n");
    printf ("<TR><TH COLSPAN=\"3\">IPX protocol: </TH>\n");		
    printf ("<TR><TD COLSPAN=\"3\"><B>\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fpipx\">\n");
    printf ("</TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"5\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");		
}

static void SetEthFilter(void)
{
/* call 3 */
    char cSourceMac[13] = "\0";	
    char cSourceMac1[4] = "\0";
    char cSourceMac2[4] = "\0";
    char cSourceMac3[4] = "\0";
    char cSourceMac4[4] = "\0";
    char cSourceMac5[4] = "\0";
    char cSourceMac6[4] = "\0";
    
    char cDestMac[13] = "\0";
    char cDestMac1[4] = "\0";
    char cDestMac2[4] = "\0";
    char cDestMac3[4] = "\0";
    char cDestMac4[4] = "\0";
    char cDestMac5[4] = "\0";
    char cDestMac6[4] = "\0";

    bool bEthernetSrcSpec;
    bool bEthernetDestSpec;
    bool bEthernetProtocolSpec;
    char cEthernetProtocol[7] ;
    int iEthernetProtocol = 0;
    	
    /* set filter for ethernet */
    CGIGetEnv ("fsm1", (char *) &cSourceMac1, 4);
    CGIGetEnv ("fsm2", (char *) &cSourceMac2, 4); 		
    CGIGetEnv ("fsm3", (char *) &cSourceMac3, 4); 		
    CGIGetEnv ("fsm4", (char *) &cSourceMac4, 4); 		
    CGIGetEnv ("fsm5", (char *) &cSourceMac5, 4); 		
    CGIGetEnv ("fsm6", (char *) &cSourceMac6, 4); 		
    strncpy (cSourceMac, cSourceMac1,2);
    strcat (cSourceMac, cSourceMac2);
    strcat (cSourceMac, cSourceMac3);
    strcat (cSourceMac, cSourceMac4);
    strcat (cSourceMac, cSourceMac5);
    strcat (cSourceMac, cSourceMac6);
    cSourceMac[13]='\0';
    
    
    if (strlen(cSourceMac) != 0)
    {
        if ((isHex(cSourceMac) == false) || (strlen(cSourceMac) < 12))
        {    
            ShowFormHeader("Set Ethernet Filter");
            printf ("<H4>Wrong Ethernet Source Address</H4> ");
            ShowEthFilterForm();
            return;
        }
        bEthernetSrcSpec = true; 
    }
    else
    {
        bEthernetSrcSpec = false;
    }
    
    /* destination */
    CGIGetEnv ("fdm1", (char *) &cDestMac1, 4);
    CGIGetEnv ("fdm2", (char *) &cDestMac2, 4); 		
    CGIGetEnv ("fdm3", (char *) &cDestMac3, 4); 		
    CGIGetEnv ("fdm4", (char *) &cDestMac4, 4); 		
    CGIGetEnv ("fdm5", (char *) &cDestMac5, 4); 		
    CGIGetEnv ("fdm6", (char *) &cDestMac6, 4); 		
    strncpy (cDestMac, cDestMac1,2);
    strcat (cDestMac, cDestMac2);
    strcat (cDestMac, cDestMac3);
    strcat (cDestMac, cDestMac4);
    strcat (cDestMac, cDestMac5);
    strcat (cDestMac, cDestMac6);
    cDestMac[13]='\0';
    
    if (strlen(cDestMac) != 0)
    {
       if ((isHex(cDestMac) == false) || (strlen(cDestMac) < 12))
        {    
            ShowFormHeader("Set Ethernet Filter");
            printf ("<H4>Wrong Ethernet Destination Address</H4> ");
            ShowEthFilterForm();
            return;
        }
        bEthernetDestSpec = true; 
    }
    else
    {
        bEthernetDestSpec = false;
    }
    
    CGIGetEnv ("fpm", (char *) &cEthernetProtocol, 7);
    iEthernetProtocol = atoi(cEthernetProtocol);
    if (iEthernetProtocol == 0)
    {
        bEthernetProtocolSpec = false;
    }
    else
    {
        bEthernetProtocolSpec = true;
    }
    
    /* inserten */
    conn = InitDBConn();
    UpdateEthFilter(bEthernetSrcSpec,bEthernetDestSpec,bEthernetProtocolSpec,
                    cSourceMac,cDestMac,iEthernetProtocol);
    TerminateDB();
    ShowConfigForm();  
}

static void SetIPFilter(void)
{
/* call 4 */
    char cSourceIP[9] = "\0";    
    char cDestIP[9] = "\0";
    char cIPSrcPort[9] = "\0";    
    char cIPDestPort[9] = "\0";
    char cIPProtocol[3] = "\0";
    
    char cSourceIP1[5] = "\0";
    char cSourceIP2[5] = "\0";
    char cSourceIP3[5] = "\0";
    char cSourceIP4[5] = "\0";
    
    char cDestIP1[5] = "\0";
    char cDestIP2[5] = "\0";
    char cDestIP3[5] = "\0";
    char cDestIP4[5] = "\0";
    
    u_int8_t iIP1 = 0;
    u_int8_t iIP2 = 0;
    u_int8_t iIP3 = 0;
    u_int8_t iIP4 = 0;

    bool bIPSrcSpec;
    bool bIPDestSpec;
    bool bIPSrcPortSpec;
    bool bIPDestPortSpec;
    bool bIPProtocolSpec;
    
    int iIPSrcPort  = 0;
    int iIPDestPort = 0;
    int iIPProtocol = 0;
    
       	
    /* set filter for IP */
    CGIGetEnv ("fsi1", (char *) &cSourceIP1, 5);
    CGIGetEnv ("fsi2", (char *) &cSourceIP2, 5); 		
    CGIGetEnv ("fsi3", (char *) &cSourceIP3, 5); 		
    CGIGetEnv ("fsi4", (char *) &cSourceIP4, 5); 		
    iIP1 = atoi (cSourceIP1);
    iIP2 = atoi (cSourceIP2);  
    iIP3 = atoi (cSourceIP3);
    iIP4 = atoi (cSourceIP4);
    
    ConvertToHex(cSourceIP,iIP1);
    ConvertToHex(cSourceIP+2,iIP2);
    ConvertToHex(cSourceIP+4,iIP3);
    ConvertToHex(cSourceIP+6,iIP4);
    cSourceIP[8]  = '\0';
    
    if (iIP1 == 0)
        bIPSrcSpec = false; 
    else
        bIPSrcSpec = true;
    
    CGIGetEnv ("fdi1", (char *) &cDestIP1, 5);
    CGIGetEnv ("fdi2", (char *) &cDestIP2, 5); 		
    CGIGetEnv ("fdi3", (char *) &cDestIP3, 5); 		
    CGIGetEnv ("fdi4", (char *) &cDestIP4, 5); 		
    iIP1 = atoi (cDestIP1);
    iIP2 = atoi (cDestIP2);  
    iIP3 = atoi (cDestIP3);
    iIP4 = atoi (cDestIP4);
    
    ConvertToHex(cDestIP,iIP1);
    ConvertToHex(cDestIP+2,iIP2);
    ConvertToHex(cDestIP+4,iIP3);
    ConvertToHex(cDestIP+6,iIP4);
    cDestIP[8]  = '\0';
    
    if (iIP1 == 0)
        bIPDestSpec = false; 
    else
        bIPDestSpec = true;

    CGIGetEnv ("fspi", (char *) &cIPSrcPort, 7);
    iIPSrcPort = atoi (cIPSrcPort);
    if (iIPSrcPort == 0)
        bIPSrcPortSpec = false;
    else
        bIPSrcPortSpec = true;
	
    CGIGetEnv ("fdpi", (char *) &cIPDestPort, 7);
    iIPDestPort = atoi (cIPDestPort);
    
    if (iIPDestPort == 0 )
        bIPDestPortSpec = false;
    else
        bIPDestPortSpec = true;
    
    CGIGetEnv ("fpi", (char *) &cIPProtocol, 7);
    iIPProtocol = atoi(cIPProtocol);
    if (iIPProtocol == 0)
        bIPProtocolSpec = false;
    else
        bIPProtocolSpec = true;
    
    /* inserten*/
    conn = InitDBConn();
    UpdateIPFilter(bIPSrcSpec,bIPDestSpec,bIPSrcPortSpec,bIPDestPortSpec,bIPProtocolSpec,cSourceIP,
	               cDestIP,iIPSrcPort,iIPDestPort,iIPProtocol);
    TerminateDB();
    ShowConfigForm();  
}

static void SetIPXFilter(void)
{
/* call 5 */

    char cSHost[14] = "\0";
    char cDHost[14] = "\0";
    
    char cSHost1[4] = "\0";
    char cSHost2[4] = "\0";
    char cSHost3[4] = "\0";
    char cSHost4[4] = "\0";
    char cSHost5[4] = "\0";
    char cSHost6[4] = "\0";
    
    char cDHost1[4] = "\0";
    char cDHost2[4] = "\0";
    char cDHost3[4] = "\0";
    char cDHost4[4] = "\0";
    char cDHost5[4] = "\0";
    char cDHost6[4] = "\0";
    
    char cSNet[7] = "\0";
    char cDNet[7] = "\0";
    
    char cSSocket[6] = "\0";
    char cDSocket[6] = "\0";
	
    char cPacketType[6] = "\0"; 
    
    bool bSHSpec;
    bool bDHSpec;
    bool bSNSpec;
    bool bDNSpec;
    bool bSSSpec;
    bool bDSSpec;
    bool bPacketType;
       
    int iPacketType;

    /*  set filter for IPX */
    CGIGetEnv ("fsipx1", (char *) &cSHost1, 4);
    CGIGetEnv ("fsipx2", (char *) &cSHost2, 4); 		
    CGIGetEnv ("fsipx3", (char *) &cSHost3, 4); 		
    CGIGetEnv ("fsipx4", (char *) &cSHost4, 4); 		
    CGIGetEnv ("fsipx5", (char *) &cSHost5, 4); 		
    CGIGetEnv ("fsipx6", (char *) &cSHost6, 4); 		

    strncpy (cSHost, cSHost1,2);
    strcat (cSHost, cSHost2);
    strcat (cSHost, cSHost3);
    strcat (cSHost, cSHost4);
    strcat (cSHost, cSHost5);
	strcat (cSHost, cSHost6);
    
    cSHost[13]='\0';

  
    if (strlen(cSHost) != 0)
    {
	if ((isHex(cSHost) == false) || (strlen(cSHost) < 12))
        {    
            ShowFormHeader("Set IPX Filter");
            printf ("<H4>Wrong IPX Source Address</H4> ");
            ShowIPXFilterForm();
            return;
        }
        bSHSpec = true; 
    }
    else
    {
        bSHSpec = false;
    }
   /* set ip dest */
    CGIGetEnv ("fdipx1", (char *) &cDHost1, 4);
    CGIGetEnv ("fdipx2", (char *) &cDHost2, 4); 		
    CGIGetEnv ("fdipx3", (char *) &cDHost3, 4); 		
    CGIGetEnv ("fdipx4", (char *) &cDHost4, 4); 		
    CGIGetEnv ("fdipx5", (char *) &cDHost5, 4); 		
    CGIGetEnv ("fdipx6", (char *) &cDHost6, 4); 		
	
    strncpy (cDHost, cDHost1,2);
    strcat (cDHost, cDHost2);
    strcat (cDHost, cDHost3);
    strcat (cDHost, cDHost4);
    strcat (cDHost, cDHost5);
    strcat (cDHost, cDHost6);
    
    cDHost[13]='\0';
    
    if (strlen(cDHost) != 0)
    {
	if ((isHex(cDHost) == false) || (strlen(cDHost) < 12))
        {    
            ShowFormHeader("Set IPX Filter");
            printf ("<H4>Wrong IPX Destination Address</H4> ");
            ShowIPXFilterForm();
            return;
        }
        bDHSpec = true; 
    }
    else
    {
        bDHSpec = false;
    }
   /* S net addr */
  
    CGIGetEnv ("fsnetipx", (char *) &cSNet, 10);
    if (strlen(cSNet) != 0)
    {
	if ((isHex(cSNet) == false) || (strlen(cSNet) < 8))
        {    
            ShowFormHeader("Set IPX Filter");
            printf ("<H4>Wrong IPX Source Net Address</H4> ");
            ShowIPXFilterForm();
            return;
        }
        bSNSpec = true; 
    }
    else
    {
        bSNSpec = false;
    }
   /*  set d net addr */
    CGIGetEnv ("fdnetipx", (char *) &cDNet, 10);
    if (strlen(cDNet) != 0)
    {
	if ((isHex(cDNet) == false) || (strlen(cDNet) < 8))
        {    
            ShowFormHeader("Set IPX Filter");
            printf ("<H4>Wrong IPX Destination Net Address</H4> ");
            ShowIPXFilterForm();
            return;
        }
        bDNSpec = true; 
    }
    else
    {
        bDNSpec = false;
    }

    /* set s socket addr */
    CGIGetEnv ("fssocketipx", (char *) &cSSocket,6);
    if (strlen(cSSocket) != 0)
    {
	if ((isHex(cSSocket) == false) || (strlen(cSSocket) < 4))
        {    
           ShowFormHeader("Set IPX Filter");
           printf ("<H4>Wrong IPX Source Socket</H4> ");
           ShowIPXFilterForm();
           return;
        }
        bSSSpec = true; 
    }
    else
    {
        bSSSpec = false;
    }

    CGIGetEnv ("fdsocketipx", (char *) &cDSocket,6);
    if (strlen(cDSocket) != 0)
    {
	if ((isHex(cDSocket) == false) || (strlen(cDSocket) < 4))
        {    
           ShowFormHeader("Set IPX Filter");
           printf ("<H4>Wrong IPX Destination Socket</H4> ");
           ShowIPXFilterForm();
           return;
        }
        bDSSpec = true; 
    }
    else
    {
        bDSSpec = false;
    }
    
    CGIGetEnv ("fpipx", (char *) &cPacketType,6);
    iPacketType = atoi(cPacketType);
    
    if (iPacketType == 0)
        bPacketType = false;
    else
        bPacketType = true;
    
    conn = InitDBConn();
    UpdateIPXFilter(bSNSpec,bSHSpec,bSSSpec,
                    bDNSpec,bDHSpec,bDSSpec,
                    bPacketType,
                    cSNet,cSHost,cSSocket,
                    cDNet,cDHost,cDSocket,
                    iPacketType);
    TerminateDB();
    ShowConfigForm();  
}

static void ShowUsrIPFilterForm (void)
{
/* call 7 */
    MYSQL* mConn;
    MYSQL_RES* mrResult;
    MYSQL_ROW mrRij;
    char sQuery[512];
    u_int32_t iAantal;
    int iTeller;

    printf ("<A HREF=\"/cgi-bin/info?name=help#filter_name_ip\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=2\"><< back</A><HR>\n");
        
    mConn = InitDBConn();
    sprintf (sQuery, "SELECT * FROM usr_ip order by username");
    mrResult = DBExec(mConn,sQuery);
    iAantal = (u_int32_t) mysql_num_rows (mrResult);
    if (iAantal != 0)
    {
        printf ("<FORM ACTION=\"/cgi-bin/filter\" METHOD=%s>",METHOD);
        printf ("<TABLE CLASS=color BORDER=1>\n");
	printf ("<TR><TH>Source Machine name:<TH>Source Port:");		
	printf ("<TR><TD WIDTH=\"300\">");
        printf ("<SELECT SIZE=\"5\" NAME=\"fsi\">\n");
        for (iTeller=0 ; iTeller < iAantal ; iTeller++)
        {
            mrRij = mysql_fetch_row(mrResult);
            printf ("<OPTION VALUE=\"%s\">%s</OPTION>",mrRij[1],mrRij[0]);
	}
        printf ("</SELECT><TD><INPUT TYPE=\"TEXT\" SIZE=\"5\" MAXLENGTH=\"5\" NAME=\"fspi\">\n");
        sprintf (sQuery, "SELECT * FROM usr_ip order by username");
        mrResult = DBExec(mConn,sQuery);
	printf ("<TR><TH>Destination Machine name:<TH>Destination Port:");		
	printf ("<TR><TD WIDTH=\"300\">");
        printf ("<SELECT SIZE=\"5\" NAME=\"fdi\">\n");
        for (iTeller=0 ; iTeller < iAantal ; iTeller++)
        {
            mrRij = mysql_fetch_row(mrResult);  
            printf ("<OPTION VALUE=\"%s\">%s</OPTION>",mrRij[1],mrRij[0]);
	}
        printf ("</SELECT><TD><INPUT TYPE=\"TEXT\" SIZE=\"5\" MAXLENGTH=\"5\" NAME=\"fdpi\">\n");    
        mysql_free_result(mrResult);
        TerminateDBConn(mConn);
	printf ("<TR><TH COLSPAN=\"2\">IP Protocol: </TH>\n");		
	printf ("<TR><TD COLSPAN=\"2\"><B>\n");
        printf ("<SELECT  NAME=\"fpi\"><OPTION VALUE=\"0\" >ALL<OPTION VALUE=\"17\">UDP<OPTION VALUE=\"1\">ICMP<OPTION VALUE=\"6\">TCP\n");
      	printf ("</SELECT></TABLE>\n");
	printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"9\">\n");
	printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
	printf ("</FORM>\n");		
    }
    else
    {
        ShowFormHeader("Set IP Filter by name\n");
        printf ("<H4> error no user list avaliable </H4>");
    }
}

static void ShowUsrEthFilterForm (void)
{
/* call 8 */
    MYSQL* mConn;
    MYSQL_RES* mrResult;
    MYSQL_ROW mrRij;
    char sQuery[512];
    u_int32_t iAantal;
    int iTeller;

    printf ("<A HREF=\"/cgi-bin/info?name=help#filter_name_eth\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=2\"><< back</A><HR>\n");

    mConn = InitDBConn();
    sprintf (sQuery, "SELECT * FROM usr_eth order by username");
    mrResult = DBExec(mConn,sQuery);
    iAantal = (u_int32_t) mysql_num_rows (mrResult);
    if (iAantal != 0)
    {
        printf ("<FORM ACTION=\"/cgi-bin/filter\" METHOD=%s>",METHOD);
        printf ("<TABLE CLASS=color BORDER=1>\n");
	printf ("<TR><TH>Source Machine name:");		
	printf ("<TR><TD>");
        printf ("<SELECT SIZE=\"5\" NAME=\"fse\">\n");
        for (iTeller=0 ; iTeller < iAantal ; iTeller++)
        {
           mrRij = mysql_fetch_row(mrResult);
           printf ("<OPTION VALUE=\"%s\">%s</OPTION>",mrRij[1],mrRij[0]);
	}
        printf ("</SELECT>");
        sprintf (sQuery, "SELECT * FROM usr_eth order by username");
        mrResult = DBExec(mConn,sQuery);
	printf ("<TR><TH>Destination Machine name:");		
	printf ("<TR><TD>");
        printf ("<SELECT SIZE=\"5\" NAME=\"fde\">\n");
        for (iTeller=0 ; iTeller < iAantal ; iTeller++)
        {
           mrRij = mysql_fetch_row(mrResult);  
           printf ("<OPTION VALUE=\"%s\">%s</OPTION>",mrRij[1],mrRij[0]);
	}
        printf ("</SELECT>");
        mysql_free_result(mrResult);
        TerminateDBConn(mConn);
        printf ("<TR><TH>Ethernet protocol: </TH>\n");		
        printf ("<TR><TD><B>\n");
        printf ("<SELECT NAME=\"fpe\"><OPTION VALUE=\"0\">ALL<OPTION VALUE=\"33079\" >IPX<OPTION VALUE=\"2054\">ARP<OPTION VALUE=\"2048\">IP\n");
 	printf ("</SELECT></TABLE>\n");
	printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"10\">\n");
	printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
	printf ("</FORM>\n");		
    }
}

static void SetUsrIPFilter(void)
{
/* call 9 */
    char cSourceIP[10] = "\0";    
    char cDestIP[10] = "\0";
    char cIPSrcPort[9] = "\0";    
    char cIPDestPort[9] = "\0";
    char cIPProtocol[3] = "\0";
    
    bool bIPSrcSpec;
    bool bIPDestSpec;
    bool bIPSrcPortSpec;
    bool bIPDestPortSpec;
    bool bIPProtocolSpec;
    
    int iIPSrcPort  = 0;
    int iIPDestPort = 0;
    int iIPProtocol = 0;
       	
   /* set filter for IP */
   CGIGetEnv ("fsi", (char *) &cSourceIP, 10);

    if (strlen(cSourceIP) == 0)
        bIPSrcSpec = false; 
    else
        bIPSrcSpec = true;
    
    CGIGetEnv ("fdi", (char *) &cDestIP, 10);
    if (strlen(cDestIP) == 0)
        bIPDestSpec = false; 
    else
        bIPDestSpec = true;
    
    CGIGetEnv ("fspi", (char *) &cIPSrcPort, 7);
    iIPSrcPort = atoi (cIPSrcPort);
    if (iIPSrcPort == 0)
        bIPSrcPortSpec = false;
    else
        bIPSrcPortSpec = true;
	
    CGIGetEnv ("fdpi", (char *) &cIPDestPort, 7);
    iIPDestPort = atoi (cIPDestPort);
    
    if (iIPDestPort == 0 )
        bIPDestPortSpec = false;
    else
        bIPDestPortSpec = true;
    
    CGIGetEnv ("fpi", (char *) &cIPProtocol, 7);
    iIPProtocol = atoi(cIPProtocol);
    if (iIPProtocol == 0)
        bIPProtocolSpec = false;
    else
        bIPProtocolSpec = true;
    
    /* inserten */
    conn = InitDBConn();
    UpdateIPFilter(bIPSrcSpec,bIPDestSpec,bIPSrcPortSpec,bIPDestPortSpec,bIPProtocolSpec,cSourceIP,
	               cDestIP,iIPSrcPort,iIPDestPort,iIPProtocol);
    TerminateDB();
    ShowConfigForm();  
}

static void SetUsrEthFilter(void)
{
/* call 10 */
    char cSourceMac[14] = "\0";	    
    char cDestMac[14] = "\0";

    bool bEthernetSrcSpec;
    bool bEthernetDestSpec;
    bool bEthernetProtocolSpec;
    char cEthernetProtocol[7] ;
    int iEthernetProtocol = 0;
    	
    /* set filter for ethernet */
    CGIGetEnv ("fse", (char *) &cSourceMac, 14);

    if (strlen(cSourceMac) != 0)
        bEthernetSrcSpec = true; 
    else
        bEthernetSrcSpec = false;
    /* destination */
    CGIGetEnv ("fde", (char *) &cDestMac, 14);
	
    if (strlen(cDestMac) != 0)
        bEthernetDestSpec = true; 
    else
        bEthernetDestSpec = false;
    
    CGIGetEnv ("fpe", (char *) &cEthernetProtocol, 7);
    iEthernetProtocol = atoi(cEthernetProtocol);
    if (iEthernetProtocol == 0)
        bEthernetProtocolSpec = false;
    else
        bEthernetProtocolSpec = true;
    
    /* inserten */
    
    conn = InitDBConn();
    UpdateEthFilter(bEthernetSrcSpec,bEthernetDestSpec,bEthernetProtocolSpec,
                    cSourceMac,cDestMac,iEthernetProtocol);
    TerminateDB();
    ShowConfigForm();  
}

int main (void)
{
    int iPID;
    char cHelp[120];
    
    HTMLHeader ("Configuration");
    iPID = GetPID ();
    CGIParseEnv ();
    CGIGetEnv ("call", (char *) &cHelp,118);
    switch (atoi(cHelp))
    {
    case 0: 
        ShowFormHeader ("Set Ethernet Filter");
        ShowEthFilterForm ();
	break;
    case 1:
    	ShowFormHeader ("Set IP Filter");
        ShowIPFilterForm ();
	 break;
    case 2:
    	ShowFormHeader ("Set IPX Filter");
        ShowIPXFilterForm ();
	break;
    case 3:
	SetEthFilter ();
        kill (iPID,SIGUSR1);
        break;    
    case 4:
	SetIPFilter ();
        kill (iPID,SIGUSR1);
        break;
    case 5:
	SetIPXFilter ();
        kill (iPID,SIGUSR1);
        break;
    case 6:
        conn = InitDBConn ();
        UpdateNoFilter ();
        TerminateDB ();
        kill (iPID,SIGUSR1);
        ShowConfigForm ();
        break;
    case 7:
        ShowFormHeader ("Set IP Filter by name");
        ShowUsrIPFilterForm ();
        break;
    case 8:
        ShowFormHeader ("Set Ethernet Filter by name");            
        ShowUsrEthFilterForm ();
        break;    
    case 9:
        SetUsrIPFilter ();
        kill (iPID, SIGUSR1);
	break;
    case 10:
        SetUsrEthFilter ();
        kill (iPID, SIGUSR1);
        break;
    default:
        ShowFormHeader ("Set Ethernet Filter");
        ShowEthFilterForm ();              
    }
    HTMLBottom ();
    return 0;
}

/* EOF */