/*******************************************************************************
**                                                                            **
**  File:        show_image_pack.c                                            **
**  Description: Displays the differnt packets in GIF format.                 **
**  Author:      Derick Rethans                                               **
**  Date:        1999-06-02                                                   **
**  Version:     0.8a1                                                        **
**  Lines:       656                                                          **
**                                                                            **
*******************************************************************************/

#include <stdlib.h>
#include "html.h"
#include "util.h"
#include "db_interface.h"
#include "forms.h"
#include <string.h>
#include "gd.h"
#include "gdfonts.h"
#include "gdfontt.h"

#define BUFSIZE          7
#define WIDTH           16
#define HEIGHT          16

static void DrawDecAsHex (gdImagePtr gipI, u_int iDataStream, int iLength, int iX, int iY, int iC);
static void DrawHexData (gdImagePtr gipI, char* cDataStream, int iLength, int iX, int iY, int iC);
static void DrawStringAsHex (char* cDataStream, int iLength, int iX, int iY, int iC);
static void ShowPacket (char* cIdent);

/************* FUNCTIONS ******************************************************/

int main (int argc, char **argv)
{
    char cIdent[120];

    printf ("Content-type: image/gif\n\n");
    CGIParseEnv ();
    CGIGetEnv ("ident", (char *) &cIdent, 118);
    ShowPacket (cIdent);
    return 0;
}

static void DrawDecAsHex (gdImagePtr gipI, u_int iDataStream, int iLength,
                          int iX, int iY, int iC)
{
    int iT = iX;
    char cHexChars[17] = "0123456789ABCDEF";

    switch (iLength)
    {
        case 4: gdImageChar (gipI, gdFontTiny, 2 + (((iX) + iT + 0) * (WIDTH / 2)), 2 + iY * HEIGHT, cHexChars[(iDataStream >> 28) % 16], iC);
		gdImageChar (gipI, gdFontTiny, 2 + (((iX) + iT + 1) * (WIDTH / 2)), 2 + iY * HEIGHT, cHexChars[(iDataStream >> 24) % 16], iC);
		gdImageChar (gipI, gdFontTiny, 2 + (((iX) + iT + 2) * (WIDTH / 2)), 2 + iY * HEIGHT, cHexChars[(iDataStream >> 20) % 16], iC);
		gdImageChar (gipI, gdFontTiny, 2 + (((iX) + iT + 3) * (WIDTH / 2)), 2 + iY * HEIGHT, cHexChars[(iDataStream >> 16) % 16], iC);
		iT += 4;
		iDataStream = iDataStream % 65536;
	case 2: gdImageChar (gipI, gdFontTiny, 2 + (((iX) + iT + 0) * (WIDTH / 2)), 2 + iY * HEIGHT, cHexChars[(iDataStream >> 12) % 16], iC);
		gdImageChar (gipI, gdFontTiny, 2 + (((iX) + iT + 1) * (WIDTH / 2)), 2 + iY * HEIGHT, cHexChars[(iDataStream >>  8) % 16], iC);	
		iT += 2;
		iDataStream = iDataStream % 256;
	case 1: gdImageChar (gipI, gdFontTiny, 2 + (((iX) + iT + 0) * (WIDTH / 2)), 2 + iY * HEIGHT, cHexChars[(iDataStream >>  4) % 16], iC);
		gdImageChar (gipI, gdFontTiny, 2 + (((iX) + iT + 1) * (WIDTH / 2)), 2 + iY * HEIGHT, cHexChars[ iDataStream        % 16], iC);
    }
}

static void DrawHexData (gdImagePtr gipI, char* cDataStream, int iLength, int iX, int iY, int iC)
{
    int iT;
    
    for (iT = 0; iT < iLength; iT++)
    {
	gdImageChar (gipI, gdFontTiny, 2 + (((iX * 2) + iT) * (WIDTH / 2)), 2 + (iY * HEIGHT), cDataStream[iT], iC);
    }
}

static void DrawStringAsHex (char* cDataStream, int iLength, int iX, int iY, int iC)
{
}

static void ShowPacket (char* cIdent)
{
    gdImagePtr gipBK;
    FILE* fBK;
    gdImagePtr gipOut;
    MYSQL_RES* mrResult;
    MYSQL* mConn;
    MYSQL_ROW mrRij;
    MYSQL_ROW mrRij2;
    MYSQL_ROW mrRij3 = 0;
    u_int iAantal = 0;
    char sQuery[560];
    char sOSIL3[10];
    char sOSIL4[10];
    int iWhite, iBlack, iRed, iBlue, iGreen;
    int iPosition = 0;
    u_int16_t uiWidth;
    int iWidth;
    int iRemainingData = 0;
    
    mConn = InitDBConn();
    sprintf (sQuery, "SELECT timestamp, dest_addr, src_addr, type, packet_length, snifstuff, OSILayer2Prot FROM packet WHERE timestamp=\"%s\"", cIdent);
    mrResult = DBExec (mConn, sQuery);
    iAantal = (u_int) mysql_num_rows (mrResult);
    if (iAantal != 1)
        HTMLError (703);
    mrRij = mysql_fetch_row(mrResult);
    
    uiWidth = atoi (mrRij[4]) * WIDTH;
    uiWidth > 8000 ? uiWidth = 8000 : uiWidth;
    gipOut = gdImageCreate (uiWidth, HEIGHT * 3);
    iWhite = gdImageColorAllocate (gipOut, 255, 255, 255);
    iBlack = gdImageColorAllocate (gipOut,   0,   0,   0);
    iRed =   gdImageColorAllocate (gipOut, 255,   0,   0);
    iBlue =  gdImageColorAllocate (gipOut,   0,   0, 255);
    iGreen = gdImageColorAllocate (gipOut,   0, 255,   0);
    gdImageFill (gipOut, 1, 1, iWhite);

    switch (atoi (mrRij[6]))
    {
	case 0: break;
	case 1: fBK = fopen ("/home/httpd/html/wesp/ethernet-bk.gif", "rb");
		if (fBK)
		{
		    gipBK = gdImageCreateFromGif (fBK);
		    gdImageCopy (gipOut, gipBK, 0 * WIDTH, HEIGHT, 0, 0, 224, 32);
		    gdImageDestroy (gipBK); 
		}
		fclose (fBK);
		gdImageFilledRectangle (gipOut, 0,   0, 14 * WIDTH, HEIGHT - 1, iRed);
		gdImageRectangle (gipOut, 0,         0, 14 * WIDTH, (HEIGHT * 3) - 1, iBlack);
		gdImageRectangle (gipOut, 6 * WIDTH, 0, 12 * WIDTH, (HEIGHT * 2) - 1, iBlack);
		gdImageRectangle (gipOut, 0,         (HEIGHT * 1) - 1, (14 * WIDTH), (HEIGHT * 2) - 1, iBlack);
		gdImageString    (gipOut, gdFontSmall, 2,                HEIGHT * 2, "Ethernet",      iBlack);
		gdImageString    (gipOut, gdFontSmall, 3,                HEIGHT * 2, "Ethernet",      iBlack);
		gdImageString    (gipOut, gdFontSmall, 2,                HEIGHT * 1, "Destination",   iBlack);
		gdImageString    (gipOut, gdFontSmall, 2 + ( 6 * WIDTH), HEIGHT * 1, "Source",        iBlack);
		gdImageString    (gipOut, gdFontSmall, 2 + (12 * WIDTH), HEIGHT * 1, "Type",          iBlack);
		DrawHexData      (gipOut, mrRij[1],        12,  0, 0,  iWhite);
		DrawHexData      (gipOut, mrRij[2],        12,  6, 0,  iWhite);
		DrawDecAsHex     (gipOut, atoi (mrRij[3]),  2, 12, 0, iWhite);
		iPosition += 14;
	        break;
	case 2: fBK = fopen ("/home/httpd/html/wesp/loopback-bk.gif", "rb");
		if (fBK)
		{
		    gipBK = gdImageCreateFromGif (fBK);
		    gdImageCopy (gipOut, gipBK, 0 * WIDTH, HEIGHT, 0, 0, 64, 32);
		    gdImageDestroy (gipBK); 
		}
		fclose (fBK);
		gdImageFilledRectangle (gipOut, 0,   0, 4 * WIDTH, HEIGHT - 1, iRed);
		gdImageRectangle (gipOut, 0,         0, 4 * WIDTH, (HEIGHT * 3) - 1, iBlack);
		gdImageRectangle (gipOut, 0,         (HEIGHT * 1) - 1, (4 * WIDTH), (HEIGHT * 2) - 1, iBlack);
		gdImageRectangle (gipOut, 2 * WIDTH, 0, 4 * WIDTH, (HEIGHT * 2) - 1, iBlack);
		gdImageString    (gipOut, gdFontSmall, 2,                HEIGHT * 2, "Loopback",      iBlack);
		gdImageString    (gipOut, gdFontSmall, 3,                HEIGHT * 2, "Loopback",      iBlack);
		gdImageString    (gipOut, gdFontSmall, 2 + ( 2 * WIDTH), HEIGHT * 1, "Type",          iBlack);
		DrawDecAsHex     (gipOut, atoi (mrRij[3]),  2,  2, 0, iWhite);
		iPosition += 4;
		break;
    }
    strncpy (sOSIL3, mrRij[3], 9);
    mysql_free_result (mrResult);
    if (strcmp (sOSIL3, "2054") == 0)
    {
        sprintf (sQuery, "SELECT ht_number, number, hard_addr_length, ip_addr_length, o_number, sender_mac, sender_ip, target_mac, target_ip FROM arp WHERE timestamp=\"%s\"", cIdent);

	mrResult = DBExec (mConn, sQuery);
	iAantal = (u_int) mysql_num_rows (mrResult);
	if (iAantal != 1)
    	    HTMLError (703);
	mrRij2 = mysql_fetch_row(mrResult);
	fBK = fopen ("/home/httpd/html/wesp/arp-bk.gif", "rb");
	if (fBK)
	{
	    gipBK = gdImageCreateFromGif (fBK);
	    gdImageCopy (gipOut, gipBK, iPosition * WIDTH, HEIGHT, 0, 0, 448, 32);
	    gdImageDestroy (gipBK); 
	}
	fclose (fBK);
	gdImageFilledRectangle (gipOut, iPosition * WIDTH,   0, ((28 + iPosition)  * WIDTH) - 1, HEIGHT - 1, iBlue);
	gdImageRectangle (gipOut, iPosition * WIDTH, 0,                ((28 + iPosition)  * WIDTH) - 1, (HEIGHT * 3) - 1, iBlack);
	gdImageRectangle (gipOut, iPosition * WIDTH, (HEIGHT * 1) - 1, ((28 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 2) * WIDTH, 0,          ((24 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 4) * WIDTH, 0,          ((18 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 5) * WIDTH, 0,          ((14 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 6) * WIDTH, 0,          (( 8 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + (iPosition * WIDTH), HEIGHT * 2, "ARP",      iBlack);
	gdImageString    (gipOut, gdFontSmall, 3 + (iPosition * WIDTH), HEIGHT * 2, "ARP",      iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + (iPosition * WIDTH), HEIGHT * 1, "Hw.",      iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 2) * WIDTH), HEIGHT * 1, "Pt.", iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 4) * WIDTH), HEIGHT * 1, "HL", iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 5) * WIDTH), HEIGHT * 1, "PL", iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 6) * WIDTH), HEIGHT * 1, "OP",  iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 8) * WIDTH), HEIGHT * 1, "Send. HW.",  iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 14) * WIDTH), HEIGHT * 1, "Send. IP.",  iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 18) * WIDTH), HEIGHT * 1, "Dest. HW.",  iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 24) * WIDTH), HEIGHT * 1, "Dest. IP.",  iBlack);
	DrawDecAsHex     (gipOut, atoi (mrRij2[0]),  2, iPosition +  0, 0,  iWhite);
	DrawDecAsHex     (gipOut, atoi (mrRij2[1]),  2, iPosition +  2, 0,  iWhite);
	DrawDecAsHex     (gipOut, atoi (mrRij2[2]),  1, iPosition +  4, 0,  iWhite);
	DrawDecAsHex     (gipOut, atoi (mrRij2[3]),  1, iPosition +  5, 0,  iWhite);
	DrawDecAsHex     (gipOut, atoi (mrRij2[4]),  2, iPosition +  6, 0,  iWhite);
	DrawHexData      (gipOut, mrRij2[5],        12, iPosition +  8, 0,  iWhite);
	DrawHexData      (gipOut, mrRij2[6],         8, iPosition + 14, 0,  iWhite);
	DrawHexData      (gipOut, mrRij2[7],        12, iPosition + 18, 0,  iWhite);
	DrawHexData      (gipOut, mrRij2[8],         8, iPosition + 24, 0,  iWhite);
        mysql_free_result (mrResult);
        iPosition += 14;
    }
    else
    if (strcmp (sOSIL3, "33079") == 0)
    {
        sprintf (sQuery, "SELECT length, transp_cntrl, ipx_type, src_network, src_host, src_socket, dest_network, dest_host, dest_socket FROM ipx i LEFT JOIN ipx_types it ON it.number=i.packet_type WHERE timestamp=\"%s\"", cIdent);

	mrResult = DBExec (mConn, sQuery);
	iAantal = (u_int) mysql_num_rows (mrResult);
	if (iAantal != 1 )
    	    HTMLError (703);
	mrRij2 = mysql_fetch_row(mrResult);
        mysql_free_result (mrResult);

    }
    else
    if (strcmp (sOSIL3, "2048") == 0)
    {
        sprintf (sQuery, "SELECT version, hdr_len, tos, tot_len, id, d, m, frag_offset, ttl, number, src_ip, dest_ip FROM ip i WHERE timestamp=\"%s\"", cIdent);
	mrResult = DBExec (mConn, sQuery);
	iAantal = (u_int) mysql_num_rows (mrResult);
	if (iAantal != 1 )
    	    HTMLError (703);
	mrRij2 = mysql_fetch_row(mrResult);
        strncpy (sOSIL4, mrRij2[9], 9);
	fBK = fopen ("/home/httpd/html/wesp/ip-bk.gif", "rb");
        if (fBK != NULL)
	{
	    gipBK = gdImageCreateFromGif (fBK);
	    gdImageCopyResized (gipOut, gipBK, iPosition * WIDTH, HEIGHT, 0, 0, WIDTH * 4 * atoi(mrRij2[1]), 32, 320, 32);
	    gdImageDestroy (gipBK); 
	    fclose (fBK);
	}
	gdImageFilledRectangle (gipOut, iPosition * WIDTH,   0, ((4 * atoi (mrRij2[1]) + iPosition)  * WIDTH) - 1, HEIGHT - 1, iBlue);
	gdImageRectangle (gipOut, iPosition * WIDTH, 0,                ((4 * atoi (mrRij2[1]) + iPosition) * WIDTH) - 1, (HEIGHT * 3) - 1, iBlack);
	gdImageRectangle (gipOut, iPosition * WIDTH, (HEIGHT * 1) - 1, ((4 * atoi (mrRij2[1]) + iPosition) * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 0) * WIDTH + WIDTH/2, 0,((20 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 1) * WIDTH, 0,          ((16 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 2) * WIDTH, 0,          ((12 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 4) * WIDTH, 0,          ((10 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 6) * WIDTH, 0,          (( 9 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 6) * WIDTH + WIDTH/8, 0,(( 8 + iPosition)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
	gdImageRectangle (gipOut, (iPosition + 6) * WIDTH + WIDTH/4, 0,(( 6 + iPosition)  * WIDTH) + ((3 * WIDTH) / 8), (HEIGHT * 2) - 1, iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + (iPosition * WIDTH),        HEIGHT * 2, "IP",      iBlack);
	gdImageString    (gipOut, gdFontSmall, 3 + (iPosition * WIDTH),        HEIGHT * 2, "IP",      iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition +  0) * WIDTH), HEIGHT * 1, "V",       iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition +  0) * WIDTH) + WIDTH / 2, HEIGHT * 1, "L",       iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition +  1) * WIDTH), HEIGHT * 1, "TS",        iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition +  2) * WIDTH), HEIGHT * 1, "T.Len",     iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition +  4) * WIDTH), HEIGHT * 1, "ID",        iBlack);

	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition +  8) * WIDTH), HEIGHT * 1, "TT",        iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition +  9) * WIDTH), HEIGHT * 1, "Pr",        iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 10) * WIDTH), HEIGHT * 1, "Hd Ck",     iBlack);
       	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 12) * WIDTH), HEIGHT * 1, "Source IP", iBlack);
	gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 16) * WIDTH), HEIGHT * 1, "Dest. IP",  iBlack);
	DrawDecAsHex     (gipOut, atoi (mrRij2[0]) * 16 + atoi (mrRij2[1]),  1, iPosition +  0, 0,  iWhite);
	DrawDecAsHex     (gipOut, atoi (mrRij2[2]),  1, iPosition +  1, 0,  iWhite);
	DrawDecAsHex     (gipOut, atol (mrRij2[3]),  2, iPosition +  2, 0,  iWhite);
	DrawDecAsHex     (gipOut, atoi (mrRij2[4]),  2, iPosition +  4, 0,  iWhite);
	DrawDecAsHex     (gipOut, atoi (mrRij2[5]) * 32768 + atoi (mrRij2[6]) * 16384 + (atoi (mrRij2[7]) / 256),  1, iPosition +  6, 0,  iWhite);
	DrawDecAsHex     (gipOut, atoi (mrRij2[7]) % 256,  1, iPosition +  7, 0,  iWhite);
        DrawDecAsHex     (gipOut, atoi (mrRij2[8]),  1, iPosition +  8, 0,  iWhite);
        DrawDecAsHex     (gipOut, atoi (mrRij2[9]),  1, iPosition +  9, 0,  iWhite);
        DrawHexData      (gipOut, "????",            4, iPosition + 10, 0,  iWhite);
	DrawHexData      (gipOut, mrRij2[10],        8, iPosition + 12, 0,  iWhite);
	DrawHexData      (gipOut, mrRij2[11],        8, iPosition + 16, 0,  iWhite);
        mysql_free_result (mrResult);
        iPosition += 20;
        iRemainingData = atol (mrRij2[3]) - 20;
	if (strcmp (sOSIL4, "1") == 0)
	{
    	    sprintf (sQuery, "SELECT type, code, ident, seqnr FROM icmp WHERE timestamp=\"%s\"", cIdent);

	    mrResult = DBExec (mConn, sQuery);
	    iAantal = (u_int) mysql_num_rows (mrResult);
	    if (iAantal != 1 )
    		HTMLError (703);
	    mrRij3 = mysql_fetch_row(mrResult);
	    fBK = fopen ("/home/httpd/html/wesp/ip-bk.gif", "rb");
            if (fBK != NULL)
	    {
	        gipBK = gdImageCreateFromGif (fBK);
	        gdImageCopyResized (gipOut, gipBK, iPosition * WIDTH, HEIGHT, 0, 0, WIDTH * 4 * atoi(mrRij2[1]), 32, 320, 32);
	        gdImageDestroy (gipBK); 
	        fclose (fBK);
	    }
            switch (atoi(mrRij3[0]))
            {
                case  0:
                case  8: iWidth = 8; /* +++++ */
                         break;
                case  3:
                case  4:
                case  5:
                case 11:
                case 12: iWidth = 12;
                         break;
                case 13:
                case 14: iWidth = 20;
                         break;
                case 15:
                case 16: iWidth =  8;
                         break;
                case 98: iWidth =  0;
                         break;
                default: iWidth =  1;
            } 
            if (iWidth != 0)
            {
	        fBK = fopen ("/home/httpd/html/wesp/icmp-bk.gif", "rb");
                if (fBK != NULL)
	        {
	            gipBK = gdImageCreateFromGif (fBK);
	            gdImageCopyResized (gipOut, gipBK, iPosition * WIDTH, HEIGHT, 0, 0, WIDTH * iWidth, 32, 96, 32);
	            gdImageDestroy (gipBK); 
	            fclose (fBK);
	        }
	        gdImageFilledRectangle (gipOut, iPosition * WIDTH,   0, ((iWidth + iPosition)  * WIDTH) - 1, HEIGHT - 1, iGreen);
                gdImageRectangle (gipOut, iPosition * WIDTH - 1, 0,                ((iPosition + iWidth) * WIDTH) - 1, (HEIGHT * 3) - 1, iBlack);
                gdImageRectangle (gipOut, iPosition * WIDTH - 1, (HEIGHT * 1) - 1, ((iPosition + iWidth) * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);

    	        gdImageString    (gipOut, gdFontSmall, 2 + (iPosition * WIDTH),        HEIGHT * 2, "ICMP",      iBlack);
	        gdImageString    (gipOut, gdFontSmall, 3 + (iPosition * WIDTH),        HEIGHT * 2, "ICMP",      iBlack);
  	        gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 0) * WIDTH),        HEIGHT * 1, "T",         iBlack);
  	        gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 1) * WIDTH),        HEIGHT * 1, "C",         iBlack);
  	        gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 2) * WIDTH),        HEIGHT * 1, "ChkS",         iBlack);
	        gdImageRectangle (gipOut, (iPosition + 1) * WIDTH, 0,          ((iPosition + 2)  * WIDTH),     (HEIGHT * 2) - 1, iBlack);
	        gdImageRectangle (gipOut, (iPosition + 4) * WIDTH, 0,          ((iPosition + iWidth)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
                DrawDecAsHex     (gipOut, atol (mrRij3[0]),  1, iPosition +  0, 0,  iBlack);
	        DrawDecAsHex     (gipOut, atol (mrRij3[1]),  1, iPosition +  1, 0,  iBlack);
                DrawHexData      (gipOut, "????",            4, iPosition +  2, 0,  iBlack);
	    
                if (atoi (mrRij3[0]) == 0 || atoi (mrRij3[0]) == 8)
                {
	            gdImageRectangle (gipOut, (iPosition + 6) * WIDTH, 0,          ((iPosition + iWidth)  * WIDTH) - 1, (HEIGHT * 2) - 1, iBlack);
    	            gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 4) * WIDTH),        HEIGHT * 1, "ID",         iBlack);
  	            gdImageString    (gipOut, gdFontSmall, 2 + ((iPosition + 6) * WIDTH),        HEIGHT * 1, "SeqNr",      iBlack);
                    DrawDecAsHex     (gipOut, atol (mrRij3[2]),  2, iPosition +  4, 0,  iBlack);
	            DrawDecAsHex     (gipOut, atol (mrRij3[3]),  2, iPosition +  6, 0,  iBlack);
                }
    	    }
            mysql_free_result (mrResult);
	}
/*	else
	if (strcmp (sOSIL4, "6") == 0)
	{
    	    sprintf (sQuery, "SELECT src_port, dest_port, seqnr, acknr, hdr_length, codebits, window, p1.portname, p2.portname FROM (tcp u LEFT JOIN portnr p1 ON u.src_port = p1.port) LEFT JOIN portnr p2 ON u.dest_port = p2.port WHERE timestamp=\"%s\"", cIdent);

	    mrResult = DBExec (mConn, sQuery);
	    iAantal = (u_int) mysql_num_rows (mrResult);
	    if (iAantal != 1 )
    		HTMLError (703);
	    mrRij2 = mysql_fetch_row(mrResult);
    	    mysql_free_result (mrResult);

	    if (strcmp (mrRij2[0], "80") == 0 || strcmp (mrRij2[1], "80") == 0 ||
	        strcmp (mrRij2[0], "21") == 0 || strcmp (mrRij2[1], "21") == 0)
	    {
        	sprintf (sQuery, "SELECT snifstuff FROM packet WHERE timestamp=\"%s\"", cIdent);

		mrResult = DBExec (mConn, sQuery);
		iAantal = (u_int) mysql_num_rows (mrResult);
		if (iAantal != 1 )
    		    HTMLError (703);
		mrRij3 = mysql_fetch_row(mrResult);
    		mysql_free_result (mrResult);
	    }
	}
	else
	if (strcmp (sOSIL4, "17") == 0)
	{
    	    sprintf (sQuery, "SELECT src_port, dest_port, length, p1.portname, p2.portname FROM (udp u LEFT JOIN portnr p1 ON u.src_port = p1.port) LEFT JOIN portnr p2 ON u.dest_port = p2.port WHERE timestamp=\"%s\"", cIdent);

	    mrResult = DBExec (mConn, sQuery);
	    iAantal = (u_int) mysql_num_rows (mrResult);
	    if (iAantal != 1 )
    		HTMLError (703);
	    mrRij2 = mysql_fetch_row(mrResult);
    	    mysql_free_result (mrResult);
	}
*/    }
    else
    {
    }
    gdImageLine (gipOut, uiWidth - 1, 0, uiWidth - 1, HEIGHT * 3 - 1, iBlack); 
    TerminateDBConn (mConn);
    gdImageHttp (gipOut);
}

/* EOF */