/*******************************************************************************
**                                                                            **
**  File:        show_packet.c                                                **
**  Description: This program displays the packets from the database.         **
**  Author:      Derick Rethans                                               **
**  Date:        1999-06-02                                                   **
**  Version:     1.0pre2                                                      **
**  Lines:       557                                                          **
**                                                                            **
*******************************************************************************/

#include <stdlib.h>
#include "html.h"
#include "util.h"
#include "db_interface.h"
#include "forms.h"
#include <string.h>

#define BUFSIZE             7
#define NR_PACK_ON_PAGE     16
#define NR_PACK_ON_PAGE_G   6
#define GREEN               "#118811"
#define RED                 "#DD5555"

static void PrintTelnet (u_int8_t* pcStream, unsigned long uiLength);
static void ShowForm (void);
static void ShowGraphicPackets (void);
static void ShowPacket (char* cIdent);
static void ShowPackets (void);
static void ShowPages (void);

/************* FUNCTIONS ******************************************************/

int main (int argc, char **argv)
{
    char cState[120];
    char cIdent[120];
    int iState;

    HTMLHeader ("Packet Viewer");
    CGIParseEnv ();
    CGIGetEnv ("call", (char *) &cState, 118);

    iState = atoi (cState);
    ShowFormHeader ("The WESP: Packet viewer");
    switch (iState)
    {
        case 0: ShowForm ();
	        break;
	case 1:
		ShowPackets ();
		break;
	case 2:
		CGIGetEnv ("ident", (char *) &cIdent, 118);
		ShowPacket (cIdent);
		break;
	case 3:
		ShowPages ();
		break;
	case 4:
		ShowGraphicPackets ();
		break;
		
	default:ShowForm ();
    }
    HTMLBottom ();
    return 0;
}

static void PrintTelnet (u_int8_t* pcStream, unsigned long uiLength)
{
    int iTeller;

    for (iTeller = 0; iTeller < uiLength; iTeller++)
    {
        if (pcStream[iTeller] > 32 && pcStream[iTeller] < 127 && pcStream[iTeller] != 60 && pcStream[iTeller] != 62)
	{
	    printf ("%c", pcStream[iTeller]);
	}
	else
	if (pcStream[iTeller] == 13 && pcStream[iTeller+1] == 10)          /* Can cause core dump maybe!!! */
	{
	    printf ("<IMG SRC=\"/wesp/CRLF.gif\" BORDER=\"0\"><BR>");
	    iTeller++;
	}
	else
	{
    	    switch ((u_int) pcStream[iTeller])
	    {
		case  0: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">NULL</FONT>", GREEN);
		         break;
		case  7: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">BEL</FONT>", GREEN);
		         break;
		case  8: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">BS</FONT>", GREEN);
		         break;
		case  9: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">HT</FONT>", GREEN);
		         break;
		case 11: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">VT</FONT>", GREEN);
		         break;
		case 12: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">FF</FONT>", GREEN);
		         break;
                case 27: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">ESC</FONT>", GREEN);
		         break;
                case 32: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">_</FONT>", GREEN);
		         break;
                case 60: printf ("&lt;");
		         break;
                case 62: printf ("&gt;");
		         break;
		case 240:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">SE</FONT>", GREEN);
		         break;
		case 241:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">NOP</FONT>", GREEN);
		         break;
		case 242:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">DM</FONT>", GREEN);
		         break;
		case 243:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">BRK</FONT>", GREEN);
		         break;
		case 244:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">IP</FONT>", GREEN);
		         break;
		case 245:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">AO</FONT>", GREEN);
		         break;
		case 246:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">AYT</FONT>", GREEN);
		         break;
		case 247:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">EC</FONT>", GREEN);
		         break;
		case 248:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">EL</FONT>", GREEN);
		         break;
		case 249:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">GA</FONT>", GREEN);
		         break;
		case 250:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">SB</FONT>", GREEN);
		         break;
		case 251:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">WILL</FONT>", GREEN);
		         break;
		case 252:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">WON'T</FONT>", GREEN);
		         break;
		case 253:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">DO</FONT>", GREEN);
		         break;
		case 254:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">DON'T</FONT>", GREEN);
		         break;
		case 255:printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">IAC</FONT>", GREEN);
		         break;
		default: printf ("<FONT COLOR=\"%s\" SIZE=\"-1\">[%d]</FONT> ", RED, (u_int) pcStream[iTeller]);
	    }
	    if ((u_int) pcStream[iTeller] > 127)
	        printf (" ");
	}
    }
}

static void ShowForm (void)
{
    printf ("<A HREF=\"/cgi-bin/info?name=help#show\">help</A><HR>\n");
    printf ("Choose from the following options:\n<UL>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/show_packet?call=1\">Show packets</A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/show_packet?call=4\">Show packets (Graphically)</A></LI>\n");
    printf ("</UL>\n");    
}

static void ShowGraphicPackets (void)
{
    u_int32_t    iAantal;
    int32_t      iBeginPos;
    char         sBeginPos[80];
    MYSQL       *mConn;
    int          iEndPos;
    int          iNewBeginPos;
    int          iNextPos;
    char         sQuery[1560];
    MYSQL_RES   *mrResult;
    MYSQL_ROW    mfRij;
    int          iT;

    mConn = InitDBConn();
    CGIGetEnv ("beginpos", sBeginPos, 78);
    iBeginPos = atoi (sBeginPos);
    mrResult = DBExec (mConn, "SET sql_big_tables = 1"); // LEUK VOOR IN PROGRAMMA DOSSIER VOOR GROTE TABELLENPROBLEEM

    sprintf (sQuery, "SELECT timestamp FROM packet ORDER BY timestamp");
    mrResult = DBExec (mConn, sQuery);
    iAantal = (u_int32_t) mysql_num_rows (mrResult);
    iEndPos = iBeginPos + NR_PACK_ON_PAGE_G;
    if (iEndPos > iAantal)
        iEndPos = iAantal;
    iNewBeginPos = iBeginPos - NR_PACK_ON_PAGE_G;
    if (iNewBeginPos < 0)
        iNewBeginPos = 0;
    iBeginPos == 0 ? printf ("begin | ") : printf ("<A HREF=\"/cgi-bin/show_packet?call=4&beginpos=0\">begin</A> | ");
    iBeginPos == 0 ? printf ("prev %d\n", NR_PACK_ON_PAGE_G) :
                     printf ("<A HREF=\"/cgi-bin/show_packet?call=4&beginpos=%d\">prev %d</A> \n", iNewBeginPos, NR_PACK_ON_PAGE_G);
    if (iAantal == 0)
        iBeginPos--;		
    printf ("| Showing: %d-%d of %d | <A HREF=\"/cgi-bin/show_packet\">top</A> |", iBeginPos+1, iEndPos, iAantal);
    iNextPos = iBeginPos + NR_PACK_ON_PAGE_G;
    if (iNextPos > iAantal - 1)
        printf (" next %d\n", NR_PACK_ON_PAGE_G);
    else
	printf (" <A HREF=\"/cgi-bin/show_packet?call=4&beginpos=%d\">next %d</A>", iNextPos, NR_PACK_ON_PAGE_G);
    printf ("<BR><HR>\n");
    if (iBeginPos != 0)
        mysql_data_seek (mrResult, iBeginPos);
    for (iT = iBeginPos; iT < iAantal; iT++)
    {
	mfRij = mysql_fetch_row(mrResult);
	if (iT > iBeginPos - 1 && iT < iBeginPos + NR_PACK_ON_PAGE_G)
	{
            printf ("<IMG SRC=\"/cgi-bin/show_image_pack?ident=%s\"><BR><BR>", mfRij[0]);
	}
	if (iT == iBeginPos + NR_PACK_ON_PAGE_G)
	    break;
    }
    mysql_free_result (mrResult);
    TerminateDBConn (mConn);
}

static void ShowPacket (char* cIdent)
{
    u_int          iAantal;
    MYSQL         *mConn;
    unsigned long *FieldLengths;
    char           sIPX[25];
    char           pcPort1[6];
    char           pcPort2[6];
    char           sQuery[560];
    MYSQL_RES     *mrResult;
    MYSQL_RES     *mrResult2;
    MYSQL_ROW      mrRij;
    MYSQL_ROW      mrRij2;
    MYSQL_ROW      mrRij3;

    mConn = InitDBConn ();
    sprintf (sQuery, "SELECT timestamp, src_addr, dest_addr, ethernet_type, type FROM packet, ethernet_types WHERE type=number AND timestamp=\"%s\"", cIdent);
    mrResult2 = DBExec (mConn, sQuery);
    iAantal = (u_int) mysql_num_rows (mrResult2);
    if (iAantal != 1)
        HTMLError (703);
    mrRij = mysql_fetch_row (mrResult2);
    printf ("<H2>Ethernet</H2>");
    printf ("<TABLE CLASS=\"color\" BORDER=\"1\">\n");
    printf ("<TR><TH><A HREF=\"/cgi-bin/info?name=glossary#timestamp\">Time stamp:</A></TH>\n");
    printf ("<TH><A HREF=\"/cgi-bin/info?name=ethernet#sender\">From:</A></TH>\n");
    printf ("<TH><A HREF=\"/cgi-bin/info?name=ethernet#to\">To:</A></TH>\n");
    printf ("<TH><A HREF=\"/cgi-bin/info?name=ethernet#type\">Type:</A></TH>\n</TR>\n");
    printf ("<TR><TD><A HREF=\"/cgi-bin/show_image_pack?ident=%s\">%s</A><TD>", mrRij[0], mrRij[0]);
    PrintEthernetAddr ((char *) mrRij[1]);
    printf ("<TD>");
    PrintEthernetAddr ((char *) mrRij[2]);
    printf ("<TD>%s</TR>\n", mrRij[3]);

    printf ("</TABLE>\n");

    mysql_free_result (mrResult2);
    if (strcmp (mrRij[4], "2054") == 0)
    {
        printf ("<H2>%s</H2>\n", mrRij[3]);
        sprintf (sQuery, "SELECT hardware_type, ethernet_type, operation, sender_mac, sender_ip, target_mac, target_ip, ao.o_number FROM arp a, hardware_types ht, ethernet_types et, arp_operations ao WHERE a.ht_number=ht.ht_number AND et.number = a.number AND ao.o_number = a.o_number AND timestamp=\"%s\"", cIdent);

	mrResult = DBExec (mConn, sQuery);
	iAantal = (u_int) mysql_num_rows (mrResult);
	if (iAantal != 1)
    	    HTMLError (703);
	mrRij2 = mysql_fetch_row (mrResult);
        mysql_free_result (mrResult);

        printf ("<TABLE CLASS=\"color\" BORDER=\"1\">\n");
	printf ("<TR>");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=arp#hwtype\">Hardware type:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=arp#ethtype\">Ethernet type:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=arp#operation\">Operation:</A></TH>\n");
        printf ("<TH>Sender MAC:<TH>Sender IP:<TH>Destination MAC:<TH>Destination IP:</TR>\n");
        printf ("<TR><TD>%s<TD>%s<TD>%s<TD>", mrRij2[0], mrRij2[1], mrRij2[2]);
	PrintEthernetAddr (mrRij2[3]);
	printf ("<TD>\n");
	PrintIPAddr (mrRij2[4]);
	printf ("<TD>\n");
	PrintEthernetAddr (mrRij2[5]);
	printf ("<TD>\n");
	PrintIPAddr (mrRij2[6]);
	printf ("</TR>\n");
	printf ("<TR><TD COLSPAN=\"7\" CLASS=\"left\"><FONT SIZE=\"-2\"><B>Textual:</B> The station with IP address ");
	PrintIPAddr (mrRij2[4]);
	printf (" and MAC address ");
	PrintEthernetAddr (mrRij2[3]);
	switch (atoi (mrRij2[7]))
	{
	    case 1: printf (" requested the MAC address of the station with IP address ");
		    PrintIPAddr (mrRij2[6]);
		    break;
	    case 2: printf (" send an ARP-response to the station with IP address ");
		    PrintIPAddr (mrRij2[6]);
		    printf (" and MAC address ");
		    PrintEthernetAddr (mrRij2[5]);
		    break;
	}
	printf ("</FONT></TR>\n");
	printf ("</TABLE>\n");
    }
    else
    if (strcmp (mrRij[4], "33079") == 0)
    {
        printf ("<H2>%s</H2>\n", mrRij[3]);
        sprintf (sQuery, "SELECT length, transp_cntrl, ipx_type, src_network, src_host, src_socket, dest_network, dest_host, dest_socket FROM ipx i LEFT JOIN ipx_types it ON it.number=i.packet_type WHERE timestamp=\"%s\"", cIdent);

	mrResult = DBExec (mConn, sQuery);
	iAantal = (u_int) mysql_num_rows (mrResult);
	if (iAantal != 1 )
    	    HTMLError (703);
	mrRij2 = mysql_fetch_row (mrResult);
        mysql_free_result (mrResult);

        printf ("<TABLE CLASS=\"color\" BORDER=\"1\">\n");
	printf ("<TR><TH>Length:<TH>Trans. Ctrl.:<TH>Type:<TH>Source:<TH>Destination:</TR>\n");
	printf ("<TR><TD>%s<TD>%s<TD>%s<TD><FONT SIZE=\"-1\">", mrRij2[0], mrRij2[1], mrRij2[2]);
	strncpy (sIPX, mrRij2[3], 9);
	strncat (sIPX, mrRij2[4], 13);
	strncat (sIPX, mrRij2[5], 5);;
	PrintIPXAddr (sIPX);
	printf ("</FONT><TD><FONT SIZE=\"-1\">");
	strncpy (sIPX, mrRij2[6], 9);
	strncat (sIPX, mrRij2[7], 13);
	strncat (sIPX, mrRij2[8], 5);
	PrintIPXAddr (sIPX);
	printf ("</FONT></TR>\n</TABLE>\n");
    }
    else
    if (strcmp (mrRij[4], "2048") == 0)
    {
        printf ("<H2><A HREF=\"/cgi-bin/info?name=ip\">%s</A></H2>\n", mrRij[3]);
        sprintf (sQuery, "SELECT version, hdr_len, tos, tot_len, id, d, m, frag_offset, ttl, ip_type, src_ip, dest_ip, i.number FROM ip i, ip_types it WHERE it.number=i.number AND timestamp=\"%s\"", cIdent);

	mrResult = DBExec (mConn, sQuery);
	iAantal = (u_int) mysql_num_rows (mrResult);
	if (iAantal != 1 )
    	    HTMLError (703);
	mrRij2 = mysql_fetch_row (mrResult);
        mysql_free_result (mrResult);

        printf ("<TABLE CLASS=\"color\" BORDER=\"1\">\n");
	printf ("<TR>");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#version\">Version:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#headerlength\">Hdr. Length:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#tos\">TOS:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#length\">Tot. Length:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#id\">ID:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#flags\">D:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#flags\">F:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#fragment\">Fragm. Offset:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#ttl\">TTL:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip#protocol\">Protocol:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip\">Source IP:</A></TH>\n");
        printf ("<TH><A HREF=\"/cgi-bin/info?name=ip\">Dest. IP:</A></TH>\n");
        printf ("</TR>\n");
        printf ("<TR><TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD>%s<TD>", mrRij2[0], mrRij2[1], mrRij2[2], mrRij2[3], mrRij2[4], mrRij2[5], mrRij2[6], mrRij2[7], mrRij2[8], mrRij2[9]);
        PrintIPAddr (mrRij2[10]);
	printf ("<TD>");
        PrintIPAddr (mrRij2[11]);
	printf ("</TR>\n");
	printf ("</TABLE>\n");
	
	if (strcmp (mrRij2[12], "1") == 0)
	{
            printf ("<H2><A HREF=\"/cgi-bin/info?name=icmp\">%s</A></H2>\n", mrRij[9]);
    	    sprintf (sQuery, "SELECT it.type, code, ident, seqnr, i.type FROM icmp i LEFT JOIN icmp_types it ON it.number=i.type WHERE timestamp=\"%s\"", cIdent);

	    mrResult = DBExec (mConn, sQuery);
	    iAantal = (u_int) mysql_num_rows (mrResult);
	    if (iAantal != 1 )
    		HTMLError (703);
	    mrRij2 = mysql_fetch_row (mrResult);
    	    mysql_free_result (mrResult);

    	    printf ("<TABLE CLASS=\"color\" BORDER=\"1\">\n");
	    printf ("<TR><TH>Type:<TH>Code:<TH>Ident:<TH>Seq. Nr</TR>\n");
	    printf ("<TR><TD>%s<TD>%s<TD>%s<TD>%s</TR>", mrRij2[0], mrRij2[1], mrRij2[2], mrRij2[3]);
	    printf ("</TABLE>\n");
	}
	else
	if (strcmp (mrRij2[12], "6") == 0)
	{
            printf ("<H2><A HREF=\"/cgi-bin/info?name=tcp\">%s</A></H2>\n", mrRij[9]);
    	    sprintf (sQuery, "SELECT src_port, dest_port, seqnr, acknr, hdr_length, codebits, window, p1.portname, p2.portname FROM (tcp u LEFT JOIN portnr p1 ON u.src_port = p1.port) LEFT JOIN portnr p2 ON u.dest_port = p2.port WHERE timestamp=\"%s\"", cIdent);

	    mrResult = DBExec (mConn, sQuery);
	    iAantal = (u_int) mysql_num_rows (mrResult);
	    if (iAantal != 1 )
    		HTMLError (703);
	    mrRij2 = mysql_fetch_row (mrResult);
    	    mysql_free_result (mrResult);

    	    printf ("<TABLE CLASS=\"color\" BORDER=\"1\">\n");
	    printf ("<TR>");
            printf ("<TH><A HREF=\"/cgi-bin/info?name=tcp#port\">Source Port:</A></TH>");
            printf ("<TH><A HREF=\"/cgi-bin/info?name=tcp#port\">Destination Port:</A></TH>");
            printf ("<TH><A HREF=\"/cgi-bin/info?name=tcp#seqnr\">Seq. Nr</A></TH>");
            printf ("<TH><A HREF=\"/cgi-bin/info?name=tcp#acknr\">Ack. Nr</A></TH>");
            printf ("<TH><A HREF=\"/cgi-bin/info?name=tcp#hdrlength\">Header Length:</A></TH>");
            printf ("<TH><A HREF=\"/cgi-bin/info?name=tcp#control\">Code bits:</A></TH>");
            printf ("<TH><A HREF=\"/cgi-bin/info?name=tcp#window\">Window:</A></TH>");
            printf ("</TR>\n");
	    printf ("<TR><TD>");
	    if (mrRij2[7] == NULL)
	        printf ("%s<TD>", mrRij2[0]);
	    else
	        printf ("%s (%s)<TD>", mrRij2[7], mrRij2[0]);
	    if (mrRij2[8] == NULL)
	        printf ("%s", mrRij2[1]);
	    else
	        printf ("%s (%s)", mrRij2[8], mrRij2[1]);
	    printf ("<TD>%lu<TD>%lu<TD>%s<TD>%s<TD>%s</TR>", atol (mrRij2[2]), atol (mrRij2[3]), mrRij2[4], mrRij2[5], mrRij2[6]);
	    strncpy (pcPort1, mrRij2[0], 5);
	    strncpy (pcPort2, mrRij2[1], 5);
	    if (strcmp (mrRij2[0], "80") == 0 || strcmp (mrRij2[1], "80") == 0 ||
	        strcmp (mrRij2[0], "23") == 0 || strcmp (mrRij2[1], "23") == 0 ||
	        strcmp (mrRij2[0], "21") == 0 || strcmp (mrRij2[1], "21") == 0)
	    {
        	sprintf (sQuery, "SELECT snifstuff FROM packet WHERE timestamp=\"%s\"", cIdent);
		
		mrResult = DBExec (mConn, sQuery);
		iAantal = (u_int) mysql_num_rows (mrResult);
		if (iAantal != 1 )
    		    HTMLError (703);
		mrRij3 = mysql_fetch_row (mrResult);
    		mysql_free_result (mrResult);
	        if (strlen (mrRij[0]) != 0)
		{
		    if (strcmp (pcPort1, "23") == 0 || strcmp (pcPort2, "23") == 0)
		    {
		        FieldLengths = mysql_fetch_lengths(mrResult);
	    	        printf ("<TR><TD COLSPAN=\"7\">");
			PrintTelnet (mrRij3[0], FieldLengths[0]);
			printf ("</TR>");
		    }
		    else
		    {
		        FieldLengths = mysql_fetch_lengths(mrResult);
	    	        printf ("<TR><TD COLSPAN=\"7\">");
			PrintTelnet (mrRij3[0], FieldLengths[0]);
			printf ("</TR>");
		    }
		}
	    }
	    printf ("</TABLE>\n");
	}
	else
	if (strcmp (mrRij2[12], "17") == 0)
	{
            printf ("<H2>%s</H2>\n", mrRij[9]);
    	    sprintf (sQuery, "SELECT src_port, dest_port, length, p1.portname, p2.portname FROM (udp u LEFT JOIN portnr p1 ON u.src_port = p1.port) LEFT JOIN portnr p2 ON u.dest_port = p2.port WHERE timestamp=\"%s\"", cIdent);

	    mrResult = DBExec (mConn, sQuery);
	    iAantal = (u_int) mysql_num_rows (mrResult);
	    if (iAantal != 1 )
    		HTMLError (703);
	    mrRij2 = mysql_fetch_row (mrResult);
    	    mysql_free_result (mrResult);

    	    printf ("<TABLE CLASS=\"color\" BORDER=\"1\">\n");
	    printf ("<TR><TH>Source Port:<TH>Destination Port:<TH>Length:</TR>\n");
	    printf ("<TR><TD>");
	    if (mrRij2[3] == NULL)
	        printf ("%s<TD>", mrRij2[0]);
	    else
	        printf ("%s (%s)<TD>", mrRij2[3], mrRij2[0]);
	    if (mrRij2[4] == NULL)
	        printf ("%s", mrRij2[1]);
	    else
	        printf ("%s (%s)", mrRij2[4], mrRij2[1]);
	    printf ("<TD>%s</TR>", mrRij2[2]);
	    printf ("</TABLE>\n");
	}
    }
    else
        HTMLError (704);
    TerminateDBConn (mConn);
}

static void ShowPackets (void)
{
    u_int32_t     iAantal;
    int32_t       iBeginPos;
    char          sBeginPos[80];
    MYSQL        *mConn;
    int           iEndPos;
    int           iNewBeginPos;
    int           iNextPos;
    char          sQuery[1560];
    MYSQL_RES    *mrResult;
    MYSQL_ROW     mfRij;
    int           iT;

    mConn = InitDBConn ();
    CGIGetEnv ("beginpos", sBeginPos, 78);
    iBeginPos = atoi (sBeginPos);
    mrResult = DBExec (mConn, "SET sql_big_tables = 1");
    sprintf (sQuery, "SELECT snifstuff FROM packet where ORDER BY timestamp");

    sprintf (sQuery, "SELECT timestamp, src_addr, dest_addr, ethernet_type, hardware_type, packet_length, left (snifstuff, 128) FROM (packet LEFT JOIN ethernet_types ON type=number) LEFT JOIN hardware_types ON OSILayer2Prot = ht_number ORDER BY timestamp");
    mrResult = DBExec (mConn, sQuery);
    iAantal = (u_int32_t) mysql_num_rows (mrResult);
    iEndPos = iBeginPos + NR_PACK_ON_PAGE;
    if (iEndPos > iAantal)
        iEndPos = iAantal;
    iNewBeginPos = iBeginPos - NR_PACK_ON_PAGE;
    if (iNewBeginPos < 0)
        iNewBeginPos = 0;
    printf ("<A HREF=\"/cgi-bin/info?name=help#packets\">help</A> | ");
    iBeginPos == 0 ? printf ("begin | ") : printf ("<A HREF=\"/cgi-bin/show_packet?call=1&beginpos=0\">begin</A> | ");
    iBeginPos == 0 ? printf ("prev %d\n", NR_PACK_ON_PAGE) :
                     printf ("<A HREF=\"/cgi-bin/show_packet?call=1&beginpos=%d\">prev %d</A>", iNewBeginPos, NR_PACK_ON_PAGE);
    if (iAantal == 0) iBeginPos--;		
    printf (" | Showing: %d-%d of %d | <A HREF=\"/cgi-bin/show_packet\">top</A> |", iBeginPos+1, iEndPos, iAantal);
    printf (" <A HREF=\"/cgi-bin/show_packet?call=3\">select page</A> |");
    iNextPos = iBeginPos + NR_PACK_ON_PAGE;
    if (iNextPos > iAantal - 1)
        printf (" next %d\n", NR_PACK_ON_PAGE);
    else
	printf (" <A HREF=\"/cgi-bin/show_packet?call=1&beginpos=%d\">next %d</A>", iNextPos, NR_PACK_ON_PAGE);
    printf ("<HR>\n");
    printf ("<TABLE CLASS=\"color\" BORDER=\"1\">\n");
    printf ("<TR><TH>Nr.<TH><A HREF=\"/cgi-bin/info?name=glossary#timestamp\">Time stamp:</A>");
    printf ("<TH><A HREF=\"/cgi-bin/info?name=glossary#device\">Device:</A>");
    printf ("<TH>Length:");
    printf ("<TH><A HREF=\"/cgi-bin/info?name=ethernet#sender\">From:</A>");
    printf ("<TH><A HREF=\"/cgi-bin/info?name=ethernet#sender\">To:</A>");
    printf ("<TH><A HREF=\"/cgi-bin/info?name=ethernet#sender\">Type:</A></TR>\n");
    if (iBeginPos != 0)
       mysql_data_seek (mrResult, iBeginPos);
    for (iT = iBeginPos; iT < iAantal; iT++)
    {
	mfRij = mysql_fetch_row(mrResult);
	if (iT > iBeginPos - 1 && iT < iBeginPos + NR_PACK_ON_PAGE)
	{
	    if (strlen (mfRij[6]) == 0)
		printf ("<TR><TD>%d<TD>", iT+1);
	    else
		printf ("<TR><TD ROWSPAN=\"2\">%d<TD>", iT+1);
	    if (mfRij[3] != NULL)
	        printf ("<A HREF=\"/cgi-bin/show_packet?call=2&ident=%s\">", mfRij[0]);
	    printf ("%s", mfRij[0]);
	    if (mfRij[3] != NULL)
	        printf ("</A>");
	    printf ("<TD>%s<TD>%s<TD>", mfRij[4], mfRij[5]);
	    PrintEthernetAddr ((char *) mfRij[1]);
	    printf ("<TD>");
	    PrintEthernetAddr ((char *) mfRij[2]);
	    printf ("<TD>%s</TR>\n", mfRij[3]);
	    if (strlen (mfRij[6]) != 0)
	    {
		if (strstr (mfRij[6], "PASS") != NULL || strstr (mfRij[6], "USER") != NULL)
		{
	    	    printf ("<TR><TD COLSPAN=\"6\" CLASS=\"RED\"><FONT SIZE=\"-1\">%s</FONT></TR>\n", mfRij[6]);
		}
		else
		{
	    	    printf ("<TR><TD COLSPAN=\"6\"><FONT SIZE=\"-1\">");
		    PrintTelnet (mfRij[6], strlen (mfRij[6]));
		    printf ("</FONT></TR>\n");
		}
	    }
	}
	if (iT == iBeginPos + NR_PACK_ON_PAGE)
	    break;
    }
    printf ("</TABLE>\n");
    mysql_free_result (mrResult);
    TerminateDBConn (mConn);
}

static void ShowPages (void)
{
    MYSQL_RES* mrResult;
    MYSQL* mConn;
    u_int32_t iAantal;
    char sQuery[1560];
    int iT;
    
    printf ("Select your page:<BR>\n<CENTER>\n");
    mConn = InitDBConn ();
    mrResult = DBExec (mConn, "SET sql_big_tables = 1");
    sprintf (sQuery, "SELECT timestamp FROM packet");
    mrResult = DBExec (mConn, sQuery);
    iAantal = (u_int32_t) mysql_num_rows (mrResult) / 16;
    for (iT = 0; iT <= iAantal; iT++)
    {
        if (iT % 20)
	    printf ("| ");
	else
	    printf ("<BR>\n");
	printf ("<A HREF=\"/cgi-bin/show_packet?call=1&beginpos=%d\">%d</A> ", iT * 16, iT + 1);
    }
    printf ("</CENTER>\n");
}

/* EOF */