/*******************************************************************************
**                                                                            **
**  File:       filter.c                                                      **
**  Desciption: CGI-Program to set the filter setting                         **
**  Author:     Bjorn Vermeulen                                               **
**  Date:       1999-06-03                                                    **
**  Version:    1.0                                                           **
**  Lines:      1128                                                          **
**                                                                            **
*******************************************************************************/

#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>

#include "html.h"
#include "db_interface.h"
#include "trigger_inst.h"
#include "interface.h"
#include "util.h"
#include "c.h"
#include "forms.h"

MYSQL * conn;

#define BUFSIZE 7

static int GetPID (void);
static void ShowEthTriggerForm (void);
static void ShowIPTriggerForm (void);
static void ShowIPXTriggerForm (void);
static void ShowStartTimeTriggerForm (void);
static void ShowStopTriggerForm (void);
static void SetEthTrigger (void);
static void SetIPTrigger (void);
static void SetIPXTrigger (void);
static void SetStartTimeTrigger (void);
static void ShowCountTriggerForm (void);
static void ShowStopTimeTriggerForm (void);
static void SetCountTrigger (void);
static void SetStopTimeTrigger (void);
static void SetStopTimeTrigger (void);
static void ShowUsrEthTriggerForm (void);
static void SetUsrIPTrigger (void);
static void SetUsrEthTrigger (void);

static int GetPID (void)
{

  int fd;
  char acWespID[BUFSIZE];
 
  if ((fd = open("/var/lock/wesp",O_RDONLY)) == -1)
  {
      return 0;
  }
  else
  {
      while ( read(fd,acWespID,BUFSIZE) >0){}
      acWespID[6]=0;      
      return atoi(acWespID);  	
  }
}

static void ShowEthTriggerForm (void)
{
/* call 0 */
    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger_eth\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=1\"><< back</A><HR>\n");
    
    printf ("<FORM ACTION=\"/cgi-bin/trigger\" METHOD=%s>",METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH COLSPAN=\"6\">Source Ethernet adres: </TH>");		
    printf ("<TR><TD COLSPAN=\"6\" WIDTH=\"300\"><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm1\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm2\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm3\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm4\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm5\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsm6\">\n");
    printf ("<TR><TH COLSPAN=\"6\">Destination Ethernet adres: </TH>");		
    printf ("<TR><TD COLSPAN=\"6\" WIDTH=\"300\"><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm1\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm2\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm3\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm4\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm5\">:\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdm6\">\n");
    printf ("<TR><TH COLSPAN=\"6\">Ethernet protocol: </TH>\n");		
    printf ("<TR><TD COLSPAN=\"6\" WIDTH=\"300\"><B>\n");
    printf ("<SELECT NAME=\"fpm\"><OPTION VALUE=\"0\">ALL<OPTION VALUE=\"33079\" >IPX<OPTION VALUE=\"2054\">ARP<OPTION VALUE=\"2048\">IP\n");	
    printf ("</SELECT></TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"5\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");		
}

static void ShowIPTriggerForm (void)
{
/* call 1 */
    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger_ip\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=1\"><< back</A><HR>\n");
    printf ("<FORM ACTION=\"/cgi-bin/trigger\" METHOD=%s>", METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH>Source IP adres:<TH>Source Port:");		
    printf ("<TR><TD WIDTH=\"300\"><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fsi1\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fsi2\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fsi3\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fsi4\">\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"5\" MAXLENGTH=\"5\" NAME=\"fspi\">\n");
    printf ("<TR><TH>Destination IP adres:<TH> Destination Port:");		
    printf ("<TR><TD WIDTH=\"300\"><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fdi1\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fdi2\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fdi3\">.\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fdi4\">\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"5\" MAXLENGTH=\"5\" NAME=\"fdpi\">\n");
    printf ("<TR><TH COLSPAN=\"2\">IP Protocol: </TH>\n");		
    printf ("<TR><TD COLSPAN=\"2\"><B>\n");
    printf ("<SELECT NAME=\"fpi\"><OPTION VALUE=\"0\" >ALL<OPTION VALUE=\"17\">UDP<OPTION VALUE=\"1\">ICMP<OPTION VALUE=\"6\">TCP\n");
    printf ("</SELECT></TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"6\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");		
}

static void ShowIPXTriggerForm (void)
{
/* call 2 */

    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger_ipx\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=1\"><< back</A><HR>\n");
    printf ("<FORM ACTION=\"/cgi-bin/trigger\" METHOD=%s>", METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH COLSPAN=\"3\">Source IPX:");
    printf ("<TR><TH> NET<TH> HOST<TH>Socket");		
    printf ("<TR><TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"8\" MAXLENGTH=\"8\" NAME=\"fsnetipx\">\n");
    printf ("<TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx1\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx2\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx3\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx4\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx5\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fsipx6\">\n");

    printf ("<TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"4\" MAXLENGTH=\"4\" NAME=\"fssocketipx\">\n");
    printf ("<TR><TH COLSPAN=\"3\">Destination IPX:");		
    printf ("<TR><TH> NET<TH> HOST<TH>Socket");		
    printf ("<TR><TD><B>");

    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"8\" MAXLENGTH=\"8\" NAME=\"fdnetipx\">\n");
    printf ("<TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx1\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx2\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx3\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx4\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx5\">-\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"fdipx6\">\n");
	
    printf ("<TD><B>");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"4\" MAXLENGTH=\"4\" NAME=\"fdsocketipx\">\n");
    printf ("<TR><TH COLSPAN=\"3\">IPX protocol: </TH>\n");		
    printf ("<TR><TD COLSPAN=\"3\"><B>\n");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"3\" MAXLENGTH=\"3\" NAME=\"fpipx\">\n");

    printf ("</TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"7\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");		
}


static void ShowStartTimeTriggerForm (void)
{
/* call 3 */
    ShowFormHeader("Set Start Time trigger");
    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger_starttime\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=1\"><< back</A><HR>\n");
    printf ("<FORM ACTION=\"/cgi-bin/trigger\" METHOD=%s>", METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH COLSPAN=\"6\">Start Time: </TH>");		
    printf ("<TR><TD> Year");
    printf ("<TD> Month");
    printf ("<TD> Day");
    printf ("<TD> Hour");
    printf ("<TD> Min");
    printf ("<TD> Sec");
    printf ("<TR>");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"4\" MAXLENGTH=\"4\" NAME=\"tst1\">-\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tst2\">-\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tst3\"> \n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tst4\">:\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tst5\">:\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tst6\">\n");
    printf ("</TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"8\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");		
}

static void ShowStopTriggerForm(void)
{
/* call 4 */
    ShowFormHeader("Set Stop Trigger");
    printf ("<A HREF=\"/cgi-bin/info?name=help#stop_trigger\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=0\"><< back to settings</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=1\"><< back to start trigger</A><HR>\n");
    ShowTriggerSetting ();
    printf ("<BR><BR>");
    printf ("Choose from the following options:\n<UL>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=13\">Set no stop type </A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=10\">Set stop type Time </A></LI>\n");
    printf ("  <LI><A HREF=\"/cgi-bin/trigger?call=9\">Set stop type Number of  packets </A></LI>\n");
    printf ("</UL>\n");    
}

static void SetEthTrigger(void)
{
/* call 5*/

    char cSourceMac[13] = "\0";	
    char cSourceMac1[4] = "\0";
    char cSourceMac2[4] = "\0";
    char cSourceMac3[4] = "\0";
    char cSourceMac4[4] = "\0";
    char cSourceMac5[4] = "\0";
    char cSourceMac6[4] = "\0";
    
    char cDestMac[13] = "\0";
    char cDestMac1[4] = "\0";
    char cDestMac2[4] = "\0";
    char cDestMac3[4] = "\0";
    char cDestMac4[4] = "\0";
    char cDestMac5[4] = "\0";
    char cDestMac6[4] = "\0";

    bool bEthernetSrcSpec;
    bool bEthernetDestSpec;
    bool bEthernetProtocolSpec;
    char cEthernetProtocol[7] ;
    int iEthernetProtocol = 0;
    	
    /* set Trigger for ethernet*/
    CGIGetEnv ("fsm1", (char *) &cSourceMac1, 4);
    CGIGetEnv ("fsm2", (char *) &cSourceMac2, 4); 		
    CGIGetEnv ("fsm3", (char *) &cSourceMac3, 4); 		
    CGIGetEnv ("fsm4", (char *) &cSourceMac4, 4); 		
    CGIGetEnv ("fsm5", (char *) &cSourceMac5, 4); 		
    CGIGetEnv ("fsm6", (char *) &cSourceMac6, 4); 		
    strncpy (cSourceMac, cSourceMac1,2);
    strcat (cSourceMac, cSourceMac2);
    strcat (cSourceMac, cSourceMac3);
    strcat (cSourceMac, cSourceMac4);
    strcat (cSourceMac, cSourceMac5);
    strcat (cSourceMac, cSourceMac6);
    cSourceMac[13]='\0';
    
    
    if (strlen(cSourceMac) != 0)
    {
        if ((isHex(cSourceMac) == false) || (strlen(cSourceMac) < 12))
        {
            ShowFormHeader("Set Ethernet Trigger");
            printf ("<H4>Wrong Ethernet Source Address</H4> ");
            ShowEthTriggerForm();
            return;
        }
        bEthernetSrcSpec = true;
    }
    else
    {
        bEthernetSrcSpec = false;
    }
    /* destination */
    CGIGetEnv ("fdm1", (char *) &cDestMac1, 4);
    CGIGetEnv ("fdm2", (char *) &cDestMac2, 4); 		
    CGIGetEnv ("fdm3", (char *) &cDestMac3, 4); 		
    CGIGetEnv ("fdm4", (char *) &cDestMac4, 4); 		
    CGIGetEnv ("fdm5", (char *) &cDestMac5, 4); 		
    CGIGetEnv ("fdm6", (char *) &cDestMac6, 4); 		
    strncpy (cDestMac, cDestMac1,2);
    strcat (cDestMac, cDestMac2);
    strcat (cDestMac, cDestMac3);
    strcat (cDestMac, cDestMac4);
    strcat (cDestMac, cDestMac5);
    strcat (cDestMac, cDestMac6);
    cDestMac[13]='\0';
    
    if (strlen(cDestMac) != 0)
    {
        if ((isHex(cDestMac) == false) || (strlen(cDestMac) < 12))
        {
            ShowFormHeader("Set Ethernet Trigger");
            printf ("<H4>Wrong Ethernet Destination Address</H4> ");
            ShowEthTriggerForm();
            return;
         }
         bEthernetDestSpec = true;
    }
    else
    {
        bEthernetDestSpec = false;
    }
    
    CGIGetEnv ("fpm", (char *) &cEthernetProtocol, 7);
    iEthernetProtocol = atoi(cEthernetProtocol);
    if (iEthernetProtocol == 0)
    {
         bEthernetProtocolSpec = false;
    }
    else
    {
         bEthernetProtocolSpec = true;
    }
    
    /* inserten */
    conn = InitDBConn();
    UpdateEthTrigger(bEthernetSrcSpec,bEthernetDestSpec,bEthernetProtocolSpec,
                    cSourceMac,cDestMac,iEthernetProtocol);
    TerminateDB();
    ShowStopTriggerForm();  
}


static void SetIPTrigger(void)
{
/* call 6 */

    char cSourceIP[9] = "\0";    
    char cDestIP[9] = "\0";
    char cIPSrcPort[9] = "\0";    
    char cIPDestPort[9] = "\0";
    char cIPProtocol[3] = "\0";
    
    char cSourceIP1[5] = "\0";
    char cSourceIP2[5] = "\0";
    char cSourceIP3[5] = "\0";
    char cSourceIP4[5] = "\0";
    
    char cDestIP1[5] = "\0";
    char cDestIP2[5] = "\0";
    char cDestIP3[5] = "\0";
    char cDestIP4[5] = "\0";
    
    u_int8_t iIP1 = 0;
    u_int8_t iIP2 = 0;
    u_int8_t iIP3 = 0;
    u_int8_t iIP4 = 0;

    bool bIPSrcSpec;
    bool bIPDestSpec;
    bool bIPSrcPortSpec;
    bool bIPDestPortSpec;
    bool bIPProtocolSpec;
    
    int iIPSrcPort  = 0;
    int iIPDestPort = 0;
    int iIPProtocol = 0;
    
       	
    /* set Trigger for IP */
    CGIGetEnv ("fsi1", (char *) &cSourceIP1, 5);
    CGIGetEnv ("fsi2", (char *) &cSourceIP2, 5); 		
    CGIGetEnv ("fsi3", (char *) &cSourceIP3, 5); 		
    CGIGetEnv ("fsi4", (char *) &cSourceIP4, 5); 		
    iIP1 = atoi (cSourceIP1);
    iIP2 = atoi (cSourceIP2);  
    iIP3 = atoi (cSourceIP3);
    iIP4 = atoi (cSourceIP4);
    
    ConvertToHex(cSourceIP,iIP1);
    ConvertToHex(cSourceIP+2,iIP2);
    ConvertToHex(cSourceIP+4,iIP3);
    ConvertToHex(cSourceIP+6,iIP4);
    cSourceIP[8]  = '\0';
    
    if (iIP1 == 0)
      bIPSrcSpec = false; 
    else
      bIPSrcSpec = true;
    
    CGIGetEnv ("fdi1", (char *) &cDestIP1, 5);
    CGIGetEnv ("fdi2", (char *) &cDestIP2, 5); 		
    CGIGetEnv ("fdi3", (char *) &cDestIP3, 5); 		
    CGIGetEnv ("fdi4", (char *) &cDestIP4, 5); 		
    iIP1 = atoi (cDestIP1);
    iIP2 = atoi (cDestIP2);  
    iIP3 = atoi (cDestIP3);
    iIP4 = atoi (cDestIP4);
    
    ConvertToHex(cDestIP,iIP1);
    ConvertToHex(cDestIP+2,iIP2);
    ConvertToHex(cDestIP+4,iIP3);
    ConvertToHex(cDestIP+6,iIP4);
    cDestIP[8]  = '\0';
    
    if (iIP1 == 0)
      bIPDestSpec = false; 
    else
      bIPDestSpec = true;
    

    CGIGetEnv ("fspi", (char *) &cIPSrcPort, 7);
    iIPSrcPort = atoi (cIPSrcPort);
    if (iIPSrcPort == 0)
      bIPSrcPortSpec = false;
    else
      bIPSrcPortSpec = true;
	
    CGIGetEnv ("fdpi", (char *) &cIPDestPort, 7);
    iIPDestPort = atoi (cIPDestPort);
    
    if (iIPDestPort == 0 )
      bIPDestPortSpec = false;
    else
      bIPDestPortSpec = true;
    
    CGIGetEnv ("fpi", (char *) &cIPProtocol, 7);
    iIPProtocol = atoi(cIPProtocol);
    if (iIPProtocol == 0)
      bIPProtocolSpec = false;
    else
      bIPProtocolSpec = true;
    
    /* inserten */
    
    conn = InitDBConn();
    UpdateIPTrigger (bIPSrcSpec,bIPDestSpec,bIPSrcPortSpec,bIPDestPortSpec,bIPProtocolSpec,cSourceIP,
	               cDestIP,iIPSrcPort,iIPDestPort,iIPProtocol);
    TerminateDB();
    ShowStopTriggerForm();  
}

static void SetIPXTrigger(void)
{
/* call 7 */

    char cSHost[14] = "\0";
    char cDHost[14] = "\0";
    char cSHost1[4] = "\0";
    char cSHost2[4] = "\0";
    char cSHost3[4] = "\0";
    char cSHost4[4] = "\0";
    char cSHost5[4] = "\0";
    char cSHost6[4] = "\0";
    
    char cDHost1[4] = "\0";
    char cDHost2[4] = "\0";
    char cDHost3[4] = "\0";
    char cDHost4[4] = "\0";
    char cDHost5[4] = "\0";
    char cDHost6[4] = "\0";
    
    char cSNet[10] = "\0";
    char cDNet[10] = "\0";
    
    char cSSocket[6] = "\0";
    char cDSocket[6] = "\0";
	
    char cPacketType[6] = "\0"; 
    
    bool bSHSpec;
    bool bDHSpec;
    bool bSNSpec;
    bool bDNSpec;
    bool bSSSpec;
    bool bDSSpec;
    bool bPacketType;
       
	int iPacketType;
    
/* set Trigger for IPX */
    CGIGetEnv ("fsipx1", (char *) &cSHost1, 4);
    CGIGetEnv ("fsipx2", (char *) &cSHost2, 4); 		
    CGIGetEnv ("fsipx3", (char *) &cSHost3, 4); 		
    CGIGetEnv ("fsipx4", (char *) &cSHost4, 4); 		
    CGIGetEnv ("fsipx5", (char *) &cSHost5, 4); 		
    CGIGetEnv ("fsipx6", (char *) &cSHost6, 4); 		

    strncpy (cSHost, cSHost1,2);
    strcat (cSHost, cSHost2);
    strcat (cSHost, cSHost3);
    strcat (cSHost, cSHost4);
    strcat (cSHost, cSHost5);
    strcat (cSHost, cSHost6);
    cSHost[13]='\0';

  
    if (strlen(cSHost) != 0)
    {
        if ((isHex(cSHost) == false) || (strlen(cSHost) < 12))
        {
           ShowFormHeader("Set IPX Trigger");
           printf ("<H4>Wrong IPX Source Address</H4> ");
           ShowIPXTriggerForm();
           return;
        }
        bSHSpec = true;
    }
    else
    {
        bSHSpec = false;
    }
    /*  set ip dest */
    CGIGetEnv ("fdipx1", (char *) &cDHost1, 4);
    CGIGetEnv ("fdipx2", (char *) &cDHost2, 4); 		
    CGIGetEnv ("fdipx3", (char *) &cDHost3, 4); 		
    CGIGetEnv ("fdipx4", (char *) &cDHost4, 4); 		
    CGIGetEnv ("fdipx5", (char *) &cDHost5, 4); 		
    CGIGetEnv ("fdipx6", (char *) &cDHost6, 4); 		
    strncpy (cDHost, cDHost1,2);
    strcat (cDHost, cDHost2);
    strcat (cDHost, cDHost3);
    strcat (cDHost, cDHost4);
    strcat (cDHost, cDHost5);
    strcat (cDHost, cDHost6);
    cDHost[13]='\0';
    
    if (strlen(cDHost) != 0)
    {
        if ((isHex(cDHost) == false) || (strlen(cDHost) < 12))
        {
            ShowFormHeader("Set IPX Trigger");
            printf ("<H4>Wrong IPX Destination Address</H4> ");
            ShowIPXTriggerForm();
            return;
         }
         bDHSpec = true;
    }
    else
    {
        bDHSpec = false;
    }
   /*  S net addr */
  
    CGIGetEnv ("fsnetipx", (char *) &cSNet, 10);
    if (strlen(cSNet) != 0)
    {
        if ((isHex(cSNet) == false) || (strlen(cSNet) < 8))
        {
            ShowFormHeader("Set IPX Trigger");
            printf ("<H4>Wrong IPX Source Net Address</H4> ");
            ShowIPXTriggerForm();
            return;
         }
         bSNSpec = true;
    }
    else
    {
         bSNSpec = false;
    }
   /* set d net addr */
    CGIGetEnv ("fdnetipx", (char *) &cDNet, 10);
    if (strlen(cDNet) != 0)
    {
        if ((isHex(cDNet) == false) || (strlen(cDNet) < 8))
        {
           ShowFormHeader ("Set IPX Trigger");
           printf ("<H4>Wrong IPX Destination Net Address</H4> ");
           ShowIPXTriggerForm();
           return;
         }
         bDNSpec = true;
    }
    else
    {
        bDNSpec = false;
    }

   /*  set s socket addr */
    CGIGetEnv ("fssocketipx", (char *) &cSSocket,6);
    if (strlen(cSSocket) != 0)
    {
        if ((isHex(cSSocket) == false) || (strlen(cSSocket) < 4))
        {
            ShowFormHeader ("Set IPX Trigger");
            printf ("<H4>Wrong IPX Source Socket</H4> ");
            ShowIPXTriggerForm ();
            return;
         }
         bSSSpec = true;
    }
    else
    {
        bSSSpec = false;
    }

    CGIGetEnv ("fdsocketipx", (char *) &cDSocket,6);
    if (strlen(cDSocket) != 0)
    {
        if ((isHex(cDSocket) == false) || (strlen(cDSocket) < 4))
        {
            ShowFormHeader ("Set IPX Trigger");
            printf ("<H4>Wrong IPX Destination Socket</H4> ");
            ShowIPXTriggerForm();
            return;
         }
         bDSSpec = true;
    }
    else
    {
      bDSSpec = false;
    }
    
    CGIGetEnv ("fpipx", (char *) &cPacketType,6);
    iPacketType = atoi(cPacketType);
    
    if (iPacketType == 0)
        bPacketType = false;
    else
        bPacketType = true;
    
    conn = InitDBConn();
    UpdateIPXTrigger(bSNSpec,bSHSpec,bSSSpec,
                    bDNSpec,bDHSpec,bDSSpec,
                    bPacketType,
                    cSNet,cSHost,cSSocket,
                    cDNet,cDHost,cDSocket,
                    iPacketType);
    TerminateDB();
    ShowStopTriggerForm();  
}

static void SetStartTimeTrigger(void)
{
/* call 8 */
	/* set time trigger */
    char cYear[6] = "\0";
    char cMonth[4] = "\0";
    char cDay[4] = "\0";
    char cHour[4] = "\0";
    char cMin[4] = "\0";
    char cSec[4] = "\0";
	
    int iYear;
    int iMonth;
    int	iDay;
    int iHour;
    int iMin;
    int iSec;
	
	
    CGIGetEnv ("tst1", (char *) &cYear, 6);
    CGIGetEnv ("tst2", (char *) &cMonth, 4);
    CGIGetEnv ("tst3", (char *) &cDay, 4);
    CGIGetEnv ("tst4", (char *) &cHour, 4);
    CGIGetEnv ("tst5", (char *) &cMin, 4);
    CGIGetEnv ("tst6", (char *) &cSec, 4);

    iYear  = atoi(cYear);
    iMonth = atoi(cMonth);
    iDay   = atoi(cDay);
    iHour  = atoi(cHour);
    iMin   = atoi(cMin);
    iSec   = atoi(cSec);

    if ( (iYear < 1980) || (iYear > 2100) ||
         (iMonth < 1)   || (iMonth >12)   ||
	 (iDay < 1 )    || (iDay >31)     ||
	 (iHour < 0)    || (iHour > 24)   ||
	 (iMin < 0)     || (iMin > 60)    ||
	 (iSec <0)      || (iSec > 60)  )
    {
	ShowFormHeader("Set Start Time Trigger");
	printf("<H4>Error in Time Trigger</H4>");
	ShowStartTimeTriggerForm();
	return;
    }
	
    conn = InitDBConn ();
    UpdateStartTimeTrigger (cYear,cMonth,cDay,cHour,cMin,cSec);	
    TerminateDB ();
    ShowStopTriggerForm();
}   

static void ShowCountTriggerForm(void)
{
/* call 9 */
    ShowFormHeader ("Set Stop Trigger after x number of packets");
    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger_count\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=4\"><< back</A><HR>\n");
    
    printf ("<FORM ACTION=\"/cgi-bin/trigger\" METHOD=%s>",METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH COLSPAN=\"6\">Stop After: </TH>");		
    printf ("<TR><TD COLSPAN=\"6\" WIDTH=\"300\">");
    printf ("<INPUT TYPE=\"TEXT\" SIZE=\"6\" MAXLENGTH=\"6\" NAME=\"tstc1\"> packets\n");
    printf ("</TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"11\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");		
}

static void ShowStopTimeTriggerForm(void)
{
/* call 10 */
    ShowFormHeader ("Set Stop Time trigger");
    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger_stoptime\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=4\"><< back</A><HR>\n");
    
    printf ("<FORM ACTION=\"/cgi-bin/trigger\" METHOD=%s>",METHOD);
    printf ("<TABLE CLASS=color BORDER=1>\n");
    printf ("<TR><TH COLSPAN=\"6\">Stop Time: </TH>");		
    printf ("<TR><TD> Year");
    printf ("<TD> Month");
    printf ("<TD> Day");
    printf ("<TD> Hour");
    printf ("<TD> Min");
    printf ("<TD> Sec");
    printf ("<TR>");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"4\" MAXLENGTH=\"4\" NAME=\"tspt1\">-\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tspt2\">-\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tspt3\">\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tspt4\">:\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tspt5\">:\n");
    printf ("<TD><INPUT TYPE=\"TEXT\" SIZE=\"2\" MAXLENGTH=\"2\" NAME=\"tspt6\">\n");
    printf ("</TABLE>\n");
    printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"12\">\n");
    printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
    printf ("</FORM>\n");	
}

static void SetCountTrigger(void)
{
/* call 11 */
    int iAantalPakketten = 0;
    char cAantalPakketten[7] = "\0";

    CGIGetEnv ("tstc1", (char *) &cAantalPakketten, 7);
    cAantalPakketten[7] = '\0';
    iAantalPakketten = atoi (cAantalPakketten);

    if (iAantalPakketten != 0)
    {
        conn = InitDBConn ();
        UpdateCountTrigger (iAantalPakketten);
        TerminateDB ();
    }
    ShowConfigForm();
}

static void SetStopTimeTrigger(void)
{
/* call 12*/
    /* set time trigger*/
    char cYear[6] = "\0";
    char cMonth[4] = "\0";
    char cDay[4] = "\0";
    char cHour[4] = "\0";
    char cMin[4] = "\0";
    char cSec[4] = "\0";

    int iYear;
    int iMonth;
    int	iDay;
    int iHour;
    int iMin;
    int iSec;

	
    CGIGetEnv ("tspt1", (char *) &cYear, 6);
    CGIGetEnv ("tspt2", (char *) &cMonth, 4);
    CGIGetEnv ("tspt3", (char *) &cDay, 4);
    CGIGetEnv ("tspt4", (char *) &cHour, 4);
    CGIGetEnv ("tspt5", (char *) &cMin, 4);
    CGIGetEnv ("tspt6", (char *) &cSec, 4);
	
    iYear  = atoi(cYear);
    iMonth = atoi(cMonth);
    iDay   = atoi(cDay);
    iHour  = atoi(cHour);
    iMin   = atoi(cMin);
    iSec   = atoi(cSec);
	
    if ( (iYear < 1980) || (iYear > 2100) ||
         (iMonth < 1)   || (iMonth >12)   ||
	 (iDay < 1 )    || (iDay >31)     ||
	 (iHour < 0)    || (iHour > 24)   ||
	 (iMin < 0)     || (iMin > 60)    ||
	 (iSec <0)      || (iSec > 60)  )
    {
        ShowFormHeader("Set Stop Time Trigger");
        printf("<H4>Error in Time Trigger</H4>");
        ShowStopTimeTriggerForm();
	return;
    }
    conn = InitDBConn ();
    UpdateStopTimeTrigger (cYear,cMonth,cDay,cHour,cMin,cSec);	
    TerminateDB ();
    ShowConfigForm ();
}   

/* call 13 --> no trigger */

static void ShowUsrIPTriggerForm (void)
{
/* call 14 */
    MYSQL* mConn;
    MYSQL_RES* mrResult;
    MYSQL_ROW mrRij;
    char sQuery[512];
    u_int32_t iAantal;
    int iTeller;

    ShowFormHeader("Set Start IP trigger by name");
    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger_name_ip\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=1\"><< back</A><HR>\n");
    
    mConn = InitDBConn();
    sprintf (sQuery, "SELECT * FROM usr_ip order by username");
    mrResult = DBExec(mConn,sQuery);
    iAantal = (u_int32_t) mysql_num_rows (mrResult);
    if (iAantal != 0)
    {
       printf ("<FORM ACTION=\"/cgi-bin/trigger\" METHOD=%s>",METHOD);
       printf ("<TABLE CLASS=color BORDER=1>\n");
       printf ("<TR><TH>Source Machine name:<TH>Source Port:");		
       printf ("<TR><TD WIDTH=\"300\">");
       printf ("<SELECT SIZE=\"5\" NAME=\"fsi\">\n");
       for (iTeller=0 ; iTeller < iAantal ; iTeller++)
        {
           mrRij = mysql_fetch_row(mrResult);
           printf ("<OPTION VALUE=\"%s\">%s</OPTION>",mrRij[1],mrRij[0]);
       }
       printf ("</SELECT><TD><INPUT TYPE=\"TEXT\" SIZE=\"5\" MAXLENGTH=\"5\" NAME=\"fspi\">\n");

       sprintf (sQuery, "SELECT * FROM usr_ip order by username");
       mrResult = DBExec(mConn,sQuery);
       printf ("<TR><TH>Destination Machine name:<TH>Destination Port:");		
       printf ("<TR><TD WIDTH=\"300\">");
       printf ("<SELECT SIZE=\"5\" NAME=\"fdi\">\n");
       for (iTeller=0 ; iTeller < iAantal ; iTeller++)
       {
           mrRij = mysql_fetch_row(mrResult);
           printf ("<OPTION VALUE=\"%s\">%s</OPTION>",mrRij[1],mrRij[0]);
       }
       printf ("</SELECT><TD><INPUT TYPE=\"TEXT\" SIZE=\"5\" MAXLENGTH=\"5\" NAME=\"fdpi\">\n");
       mysql_free_result(mrResult);
       TerminateDBConn(mConn);
   	
       printf ("<TR><TH COLSPAN=\"2\">IP Protocol: </TH>\n");		
       printf ("<TR><TD COLSPAN=\"2\"><B>\n");
       printf ("<SELECT  NAME=\"fpi\"><OPTION VALUE=\"0\" >ALL<OPTION VALUE=\"17\">UDP<OPTION VALUE=\"1\">ICMP<OPTION VALUE=\"6\">TCP\n");
       printf ("</SELECT></TABLE>\n");
       printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"16\">\n");
       printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
       printf ("</FORM>\n");		
    }
    else
    {
       ShowFormHeader("Set IP Filter by name\n");
       printf ("<H4> error no user list avaliable </H4>");
    }
}

static void ShowUsrEthTriggerForm (void)
{
/* call 15 */
    MYSQL* mConn;
    MYSQL_RES* mrResult;
    MYSQL_ROW mrRij;
    char sQuery[512];
    u_int32_t iAantal;
    int iTeller;
    ShowFormHeader("Set Start Ethernet trigger by name");
    printf ("<A HREF=\"/cgi-bin/info?name=help#trigger_name_eth\">help</A> | \n");
    printf ("<A HREF=\"/cgi-bin/settings?call=1\"><< back</A><HR>\n");
     
    mConn = InitDBConn();
    sprintf (sQuery, "SELECT * FROM usr_eth order by username");
    mrResult = DBExec(mConn,sQuery);
    iAantal = (u_int32_t) mysql_num_rows (mrResult);
    if (iAantal != 0)
    {
        printf ("<FORM ACTION=\"/cgi-bin/trigger\" METHOD=%s>",METHOD);
        printf ("<TABLE CLASS=color BORDER=1>\n");
        printf ("<TR><TH>Source Machine name:");		
        printf ("<TH>Destination Machine name:");		

        printf ("<TR><TD>");
        printf ("<SELECT SIZE=\"5\" NAME=\"fse\">\n");
        for (iTeller=0 ; iTeller < iAantal ; iTeller++)
        {
            mrRij = mysql_fetch_row(mrResult);
            printf ("<OPTION VALUE=\"%s\">%s</OPTION>",mrRij[1],mrRij[0]);
	}
        printf ("</SELECT>");
        sprintf (sQuery, "SELECT * FROM usr_eth order by username");
        mrResult = DBExec(mConn,sQuery);
        printf ("<TD>");
        printf ("<SELECT SIZE=\"5\" NAME=\"fde\">\n");
        for (iTeller=0 ; iTeller < iAantal ; iTeller++)
        {
            mrRij = mysql_fetch_row(mrResult);
            printf ("<OPTION VALUE=\"%s\">%s</OPTION>",mrRij[1],mrRij[0]);
	}
        printf ("</SELECT>");
        mysql_free_result(mrResult);
        TerminateDBConn(mConn);
        printf ("<TR><TH COLSPAN=\"2\">Ethernet protocol: </TH>\n");		
        printf ("<TR><TD COLSPAN=\"2\"><B>\n");
        printf ("<SELECT NAME=\"fpe\"><OPTION VALUE=\"0\">ALL<OPTION VALUE=\"33079\" >IPX<OPTION VALUE=\"2054\">ARP<OPTION VALUE=\"2048\">IP\n");
        printf ("</SELECT></TABLE>\n");
	printf ("<INPUT TYPE=\"HIDDEN\" NAME=\"call\" VALUE=\"17\">\n");
	printf ("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Submit\">\n");
	printf ("</FORM>\n");		
    }
    else
    {
       ShowFormHeader("Set Eth Trigger by name\n");
       printf ("<H4> error no user list avaliable </H4>");
       printf ("<BR><BR><A HREF=\"/cgi-bin/settings?call=1\"> <<Back </A>");
    }
}

static void SetUsrIPTrigger(void)
{
/* call 16*/

    char cSourceIP[10] = "\0";
    char cDestIP[10] = "\0";
    char cIPSrcPort[9] = "\0";
    char cIPDestPort[9] = "\0";
    char cIPProtocol[3] = "\0";

    bool bIPSrcSpec;
    bool bIPDestSpec;
    bool bIPSrcPortSpec;
    bool bIPDestPortSpec;
    bool bIPProtocolSpec;

    int iIPSrcPort  = 0;
    int iIPDestPort = 0;
    int iIPProtocol = 0;

    /* set filter for IP */
    CGIGetEnv ("fsi", (char *) &cSourceIP, 10);

    if (strlen(cSourceIP) == 0)
        bIPSrcSpec = false;
    else
      bIPSrcSpec = true;

    CGIGetEnv ("fdi", (char *) &cDestIP, 10);
    if (strlen(cDestIP) == 0)
        bIPDestSpec = false;
    else
        bIPDestSpec = true;

    CGIGetEnv ("fspi", (char *) &cIPSrcPort, 7);
    iIPSrcPort = atoi (cIPSrcPort);
    if (iIPSrcPort == 0)
        bIPSrcPortSpec = false;
    else
        bIPSrcPortSpec = true;
	
    CGIGetEnv ("fdpi", (char *) &cIPDestPort, 7);
    iIPDestPort = atoi (cIPDestPort);

    if (iIPDestPort == 0 )
        bIPDestPortSpec = false;
    else
        bIPDestPortSpec = true;

    CGIGetEnv ("fpi", (char *) &cIPProtocol, 7);
    iIPProtocol = atoi (cIPProtocol);
    if (iIPProtocol == 0)
        bIPProtocolSpec = false;
    else
        bIPProtocolSpec = true;

    /* inserten */

    conn = InitDBConn ();
    UpdateIPTrigger (bIPSrcSpec,bIPDestSpec,bIPSrcPortSpec,bIPDestPortSpec,bIPProtocolSpec,cSourceIP,
	               cDestIP,iIPSrcPort,iIPDestPort,iIPProtocol);
    TerminateDB ();
    ShowStopTriggerForm ();
}


static void SetUsrEthTrigger(void)
{
/* call 17 */

    char cSourceMac[14] = "\0";	
    char cDestMac[14] = "\0";

    bool bEthernetSrcSpec;
    bool bEthernetDestSpec;
    bool bEthernetProtocolSpec;
    char cEthernetProtocol[7] ;
    int iEthernetProtocol = 0;
    	
    /* set filter for ethernet */
    CGIGetEnv ("fse", (char *) &cSourceMac, 14);

    if (strlen(cSourceMac) != 0)
    {
        bEthernetSrcSpec = true;
    }
    else
    {
        bEthernetSrcSpec = false;
    }
    /* destination */
    CGIGetEnv ("fde", (char *) &cDestMac, 14);
	
    if (strlen(cDestMac) != 0)
    {
        bEthernetDestSpec = true;
    }
    else
    {
        bEthernetDestSpec = false;
    }

    CGIGetEnv ("fpe", (char *) &cEthernetProtocol, 7);
    iEthernetProtocol = atoi(cEthernetProtocol);
    if (iEthernetProtocol == 0)
    {
        bEthernetProtocolSpec = false;
    }
    else
    {
        bEthernetProtocolSpec = true;
    }

    /* inserten */

    conn = InitDBConn ();
    UpdateEthTrigger (bEthernetSrcSpec,bEthernetDestSpec,bEthernetProtocolSpec,
                    cSourceMac,cDestMac,iEthernetProtocol);
    TerminateDB ();
    ShowStopTriggerForm ();
}

int main (void)
{
    int iPID;
    char cHelp[120];
    
    HTMLHeader ("Configuration");
    iPID = GetPID ();
    CGIParseEnv ();
    CGIGetEnv("call", (char *) &cHelp,118);
    switch (atoi(cHelp))
    {
        case 0:
            ShowFormHeader("Set Start Ethernet Trigger");
            ShowEthTriggerForm();
	    break;
        case 1:
            ShowFormHeader("Set Start IP Trigger");
            ShowIPTriggerForm();
	    break;
        case 2:
            ShowFormHeader("Set Start IPX Trigger");
            ShowIPXTriggerForm();
            break;
        case 3:
            ShowStartTimeTriggerForm();
            break;
        case 4:
            conn = InitDBConn ();
            UpdateNoStartTrigger ();
            TerminateDB ();
            ShowStopTriggerForm();
            break;
        case 5:
            SetEthTrigger();
            break;
        case 6:
            SetIPTrigger();			
            break;
        case 7:
            SetIPXTrigger();			
            break;
        case 8:
            SetStartTimeTrigger();	
            break;
        case 9:
            ShowCountTriggerForm();			
            break;
        case 10:	
            ShowStopTimeTriggerForm();
            break;
        case 11:
            SetCountTrigger();							
            kill (iPID,SIGUSR1);
            break;
        case 12:
            SetStopTimeTrigger();
            kill (iPID,SIGUSR1);
            break;
        case 13:
            conn = InitDBConn ();
            UpdateNoStopTrigger();
            TerminateDB ();
            kill (iPID,SIGUSR1);
            ShowConfigForm();
            break;
        case 14:
            ShowUsrIPTriggerForm();
      	    break;
        case 15:
            ShowUsrEthTriggerForm();
            break;
        case 16:
            SetUsrIPTrigger();
            kill (iPID,SIGUSR1);
            break;
       	case 17:
            SetUsrEthTrigger();
            kill (iPID,SIGUSR1);
            break;
        default:
            break;
    }
    HTMLBottom();
    return 0;
}

/* EOF */