/*******************************************************************************
**                                                                            **
** File:        delete_users                                                  **       **
** Description: Program deletes user from tables usr_ip and usr_eth           **
** Author:      Jeroen Scheeres                                               **
** Date:        1999-06-03                                                    **
** Version:     1.0                                                           **
** Lines:       66                                                            **
**                                                                            **
*******************************************************************************/

#include <unistd.h>
#include <mysql/mysql.h>
#include <string.h>
#include <ctype.h>

#include "db_interface.h"
#include "util.h"

static MYSQL* conn;
static MYSQL_RES* result;

static void DeleteIPUsers (void);
static void DeleteEthUsers (void);

/*************** FUNCTIONS ****************************************************/

void DeleteIPUsers (void)
{   
    char cStatement[100] = "\0";
    
    conn = InitDBConn ();
    
    sprintf (cStatement, "DELETE FROM usr_ip WHERE (1=1)"); 
    result = DBExec (conn, cStatement);
    
    TerminateDB ();
}

void DeleteEthUsers (void)
{   
    char cStatement[100] = "\0";
      
    conn = InitDBConn ();
    
    sprintf (cStatement, "DELETE FROM usr_eth WHERE (1=1)"); 
    result = DBExec (conn, cStatement);
    
    TerminateDB ();
}

int main (int argc, char ** argv)
{
    int iOp;
    
    printf ("(c) 1999 The WESP\n");
          
    while ((iOp = getopt(argc, argv, "ie") ) != EOF) 
    switch (iOp)
    {
      case 'i':
          printf ("Deleting IP userlist.\n");
          DeleteIPUsers ();
          break;
      case 'e':       
          printf ("Deleting Ethernet userlist.\n");
          DeleteEthUsers ();
          break;
      default :
          printf (" usage: delete_users [-i] [-e]\n"); 
    }
    if (argc==0)
        printf (" usage: delete_users [-i] [-e]\n"); 
    return 0;
}