/*******************************************************************************
**                                                                            **
** File:        insert_constants.c                                            **
** Description: program inserts constants into the database                   ** 
** Author:      Jeroen Scheeres                                               **
** Date:        1999-06-03                                                    **
** Version:     1.0                                                           **
** Lines:       155                                                           **
**                                                                            **
*******************************************************************************/ 

#include <mysql/mysql.h>

#include "db_interface.h"


static MYSQL* conn;
static MYSQL_RES* result;

int main (void)
{
/* Connecting database to server */

    conn = InitDBConn ();

/* Insert hardware_types */

    result = DBExec (conn, "INSERT INTO hardware_types VALUES
				(0, 'RAW (PPP)')");
    result = DBExec (conn, "INSERT INTO hardware_types VALUES
				(1, 'Ethernet')");
    result = DBExec (conn, "INSERT INTO hardware_types VALUES
				(2, 'Loopback')");

/* Insert ethernet_types */

    result = DBExec (conn, "INSERT INTO ethernet_types VALUES
				(2048, 'IP')");
    result = DBExec (conn, "INSERT INTO ethernet_types VALUES
				(2054, 'ARP')");
    result = DBExec (conn, "INSERT INTO ethernet_types VALUES
				(33079, 'IPX')");

/* Insert ip_types */

    result = DBExec (conn, "INSERT INTO ip_types VALUES
				(1, 'ICMP')");
    result = DBExec (conn, "INSERT INTO ip_types VALUES
				(4, 'IP in IP')");
    result = DBExec (conn, "INSERT INTO ip_types VALUES
				(6, 'TCP')");
    result = DBExec (conn, "INSERT INTO ip_types VALUES
				(17, 'UDP')");

/* Insert ipx_types */

    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(0, 'Unknown Packet Type (IPX)')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(1, 'Routing Information Protocol (RIP)')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(2, 'Echo Packet')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(3, 'Error Packet')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(4, 'Packet Exchange Packet (IPX)')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(5, 'Sequenced Packet Exchange (SPX)')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(17, 'NetWare Core Protocol (NCP)')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(0x80, 'Ethernet')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(0x81, 'Raw 802.3 ')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(0x82, '802.3/802.2')");
    result = DBExec (conn, "INSERT INTO ipx_types VALUES
				(0x83, '802.3/SNAP')");


/* Insert arp_operations */

    result = DBExec (conn, "INSERT INTO arp_operations VALUES
				(1, 'ARP request')");
    result = DBExec (conn, "INSERT INTO arp_operations VALUES
				(2, 'ARP response')");
    result = DBExec (conn, "INSERT INTO arp_operations VALUES
				(3, 'RARP request')");
    result = DBExec (conn, "INSERT INTO arp_operations VALUES
				(4, 'RARP response')");

/* Insert portnr */

    result = DBExec (conn, "INSERT INTO portnr VALUES
				(20, 'File Transfer [data]')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(21, 'File Transfer [control]')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(23, 'Telnet')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(25, 'Simple Mail Transfer')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(79, 'Finger')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(80, 'World Wide Web HTTP')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(110, 'Post Office Protocol 3')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(111, 'RPC Port Mapper')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(119, 'Network News Transfer Protocol')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(137, 'NETBIOS Name Service')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(138, 'NETBIOS Datagram Service')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(139, 'NETBIOS Session Service')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(194, 'Internet Relay Chat Protocol')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(396, 'Novell Netware over IP')");
    result = DBExec (conn, "INSERT INTO portnr VALUES
				(513, 'login')");

/* Insert icmp_types */

    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(0, 'Echo reply')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(3, 'Destination unreachable')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(4, 'Source quench')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(5, 'Redirect')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(8, 'Echo request')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(11, 'Time exceeded')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(12, 'Parameter problem')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(13, 'Timestamp request')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(14, 'Timestamp reply')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(15, 'Information request')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(16, 'Information reply')");
    result = DBExec (conn, "INSERT INTO icmp_types VALUES
				(98, 'Fragmented packet')");

    TerminateDB ();
    
    return 0;
}