/*******************************************************************************
**                                                                            **
** File:       insert_users.c                                                 **
** Descrition: program inserts user into the tables usr_ip and usr_eth        **
** Author:     Jeroen Scheeres                                                **
** Date:       1999-06-03                                                     **
** Version:    1.0                                                            **
** Lines:      227                                                            **
**                                                                            **
*******************************************************************************/

#include <unistd.h>
#include <mysql/mysql.h>
#include <string.h>
#include <ctype.h>

#include "db_interface.h"
#include "util.h"


static           MYSQL* conn;
static           MYSQL_RES* result;

char*            cIPFile;
char*            cEthFile; 

int FindDot (char cIP[128], int iMaskNumber);
void FindDotEth (char cEth[128], char *cBuffer);
void ReadIPFile (void);
void ReadEthFile (void);

/*********** FUNCTIONS ********************************************************/

int FindDot (char cIP[128], int iMaskNumber)
{
    int iTeller  = 0;
    int iTeller1 = 0;
    char cBuffer[4];

    switch(iMaskNumber)
    {
    case 1:  
        while (cIP[iTeller] !='.')
        {
            cBuffer[iTeller] = cIP[iTeller];  
            iTeller++;
        }
        break;
    case 2:
        while (cIP[iTeller] != '.')
        {
            iTeller++; 
        }
        iTeller++;    
        
	while (cIP[iTeller] != '.')
        {
            cBuffer[iTeller1] = cIP[iTeller];  
            iTeller1++;
            iTeller++;
        }
        cBuffer[iTeller1]='\0';
        break;
    case 3:
        while (cIP[iTeller] != '.')
        {
            iTeller++; 
        }
        iTeller++;    
        while (cIP[iTeller] != '.')
        {
            iTeller++; 
        }
        iTeller++;    
    
        while (cIP[iTeller] != '.')
        {
            cBuffer[iTeller1] = cIP[iTeller];  
            iTeller1++;
            iTeller++;
        }
        cBuffer[iTeller1] = '\0';  
        break;
    case 4:
        while (cIP[iTeller] != '.')
        {
            iTeller++; 
        }
        iTeller++;    
        
	while (cIP[iTeller] != '.')
        {
            iTeller++; 
        }
        iTeller++;    
        
	while (cIP[iTeller] != '.')
        {
             iTeller++; 
        }
        iTeller++;    
    
        while (cIP[iTeller] != '\0')
        {
             cBuffer[iTeller1] = cIP[iTeller];  
             iTeller1++;
             iTeller++;
        }
        cBuffer[iTeller1] = '\0';    
        break;
    default:
        return 0;
    }
  
    return atoi (cBuffer);   
}

void FindDotEth(char cEth[128], char *cBuffer)
{
    int iTeller  = 0;
    int iTeller1 = 0;  
    while (cEth[iTeller] != '.')
    {
      cBuffer[iTeller1] = toupper (cEth[iTeller]);  
      iTeller++;
      iTeller1++;
    } 
    iTeller++;        

    while (cEth[iTeller] != '.')
    {
        cBuffer[iTeller1] = toupper (cEth[iTeller]);  
        iTeller1++;
        iTeller++;
    }
    iTeller++;  
    while (cEth[iTeller] != '\0')
    {
      cBuffer[iTeller1] = toupper (cEth[iTeller]);
      iTeller1++;
      iTeller++;
    }
    
    cBuffer[iTeller1] = '\0';  
}

void ReadIPFile()
{   
    char cName[128];
    char cIP[128];
    char cHex[10] = "\0";
    char cStatement[100] = "\0";
  
    FILE *fIn;
  
    if ((fIn = fopen (cIPFile, "r")) == NULL)
    {
        printf ("Eops! file not found\n");
    }
    else
    {
        conn = InitDBConn ();
        while (fscanf (fIn, "%s%s", cName, cIP) != EOF)
        { 
            printf ("%-32s : %-15s", cName, cIP);
            ConvertToHex (cHex + 0, FindDot (cIP,1));
            ConvertToHex (cHex + 2, FindDot (cIP,2));
            ConvertToHex (cHex + 4, FindDot (cIP,3));
            ConvertToHex (cHex + 6, FindDot (cIP,4));
            cHex[8]  = '\0';
            printf(" --> %-8s\n", cHex);
            sprintf (cStatement, "INSERT INTO usr_ip VALUES (\"%s\", \"%s\")", cName, cHex); 
            result = DBExec (conn, cStatement);
            cIP[0] = '\0';
            cHex[0] = '\0';
          }
          TerminateDB ();
    }  
}

void ReadEthFile()
{   
    char cName[128];
    char cEth[15];
    char cHex[13] = "\0";
    char cStatement[100] = "\0";
  
    FILE *fIn;
  
    if ((fIn = fopen (cEthFile, "r")) == NULL)
    {
        printf ("Eops! file not found\n");
    }
    else
    {
        conn = InitDBConn ();
        while (fscanf (fIn, "%s%s", cName, cEth) != EOF)
        { 
            printf ("%-32s : %-15s", cName, cEth);
            FindDotEth(cEth, cHex); 
            printf(" --> %-8s\n", cHex);
            sprintf (cStatement, "INSERT INTO usr_eth VALUES (\"%s\", \"%s\")", cName, cHex); 
            result = DBExec (conn, cStatement);
            cHex[0] = '\0';
         }
         TerminateDB ();
     }
}

int main (int argc, char ** argv)
{
  int iOp;
  
  printf ("(c) 1999 The WESP\n");
        
  while ((iOp = getopt(argc, argv, "i:e:")) != EOF) 
  switch (iOp)
  {  
    case 'i':
        cIPFile = optarg;
        printf ("Inserting IP userlist %s.\n", cIPFile);
        ReadIPFile();
        break;
    case 'e':        
        cEthFile = optarg;
        printf ("Inserting IP userlist %s.\n", cEthFile);
        ReadEthFile();
        break;
    default :
        printf (" usage: insert_users [-i filename] [-e filename]\n"); 
  }
  if (argc == 0)
        printf (" usage: insert_users [-i filename] [-e filename]\n"); 
  
  
    return 0;
}